using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public class PrintablePage : Page
{
    private string _printID = null;

    protected override void OnPreInit(EventArgs e)
    {
        _printID = Request.QueryString["print"];
        if (!String.IsNullOrEmpty(_printID))
            this.MasterPageFile = "Print.master";

        base.OnPreInit(e);
    }

    protected override void OnInit(EventArgs e)
    {
        if (!String.IsNullOrEmpty(_printID)) {
            PrintMaster master = (PrintMaster)this.Master;
            master.DisableNoneSelectedContent(_printID);
        }

        base.OnInit(e);
    }

    /*
     *   ̿ϸ PrintMaster Ŭ  
     * ʿ䰡    ˰ Ѵ.
     * 
    protected override void OnInit(EventArgs e)
    {
        if (!String.IsNullOrEmpty(_printID))
            DisableNoneSelectedContent(this.Master);

        base.OnInit(e);
    }

    private bool DisableNoneSelectedContent(Control parent) {

        bool done = false;
        foreach (Control ctl in parent.Controls) {
            if (typeof(ContentPlaceHolder) == ctl.GetType()) {
                if (!ctl.ID.Equals(_printID))
                    ctl.Visible = false;

                done = true;
            }

            if (!done && !(ctl is MasterPage))
                done = DisableNoneSelectedContent(ctl);
        }

        return done;
    }
    */
}
