<%@ Page Language="C#" %>
<script runat="server">
    protected void GridView1_DataBound(object sender, EventArgs e)
    {
        GridView gv = (GridView)sender;
        GridViewRow pagerRow = gv.BottomPagerRow;

        Label pageNum = (Label)pagerRow.Cells[0].FindControl("PageNumberLabel");
        Label totalNum = (Label)pagerRow.Cells[0].FindControl("TotalPagesLabel");

        if ((pageNum != null) && (totalNum != null)) {
            int page = gv.PageIndex + 1;
            int count = gv.PageCount;

            pageNum.Text = page.ToString();
            totalNum.Text = count.ToString();
        }

        CreateNumericPager(gv, pagerRow);
        CreateDropDownListPager(gv, pagerRow);
    }

    void CreateDropDownListPager(GridView gv, GridViewRow pagerRow)
    {
        DropDownList pageList = (DropDownList)pagerRow.Cells[0].FindControl("DropDownList1");
        if (pageList != null) {
            for (int i = 0; i < gv.PageCount; i++) {
                int pageNumber = i + 1;
                ListItem item = new ListItem(pageNumber.ToString());

                if (i == gv.PageIndex)
                    item.Selected = true;

                pageList.Items.Add(item);
            }
        }
    }
    
    void DropDownList1_SelectedIndexChanged(Object sender, EventArgs e)
    {
        DropDownList pageList = (DropDownList)GridView1.BottomPagerRow.Cells[0].FindControl("DropDownList1");

        GridView1.PageIndex = pageList.SelectedIndex;
    }
    
    void CreateNumericPager(GridView gv, GridViewRow pagerRow)
    {
        Control btn;
        for (int i = 1; i <= 10; i++) {
            btn = pagerRow.Cells[0].FindControl("btnNum" + i);
            btn.Visible = false;
        }

        Button btnPrevList = (Button)pagerRow.Cells[0].FindControl("btnPrevList");
        btnPrevList.Visible = false;
        Button btnFirst = (Button)pagerRow.Cells[0].FindControl("btnFirst");
        btnFirst.Visible = false;
        Literal lFirst = (Literal)pagerRow.Cells[0].FindControl("lFirst");
        lFirst.Visible = false;

        Literal lLast = (Literal)pagerRow.Cells[0].FindControl("lLast");
        lLast.Visible = false;
        Button btnLast = (Button)pagerRow.Cells[0].FindControl("btnLast");
        btnLast.Visible = false;
        Button btnNextList = (Button)pagerRow.Cells[0].FindControl("btnNextList");
        btnNextList.Visible = false;
        
        int pageCount = gv.PageCount;
        int pageIndex = gv.PageIndex + 1;
        int pageButtonCount = gv.PagerSettings.PageButtonCount;
        int lastPage = pageButtonCount;
        if (pageCount < lastPage)
            lastPage = pageCount;

        int first = 1;
        int last = lastPage;
        if (pageIndex > last) {
            first = gv.PageIndex / pageButtonCount * pageButtonCount + 1;
            last = first + pageButtonCount - 1;
            if (last > pageCount)
                last = pageCount;

            if (last - first + 1 < pageButtonCount)
                first = Math.Max(1, last - pageButtonCount + 1);
        }
        if (first != 1) {
            btnPrevList.Visible = true;

            int t = first - 1;
            btnPrevList.CommandArgument = t.ToString();
            btnPrevList.Text = "" + pageButtonCount + "";

            btnFirst.Visible = true;
            lFirst.Visible = true;
        }
        int count = 1;
        for (int i = first; i <= last; i++, count++) {
            string str = i.ToString();
            Button numButton = (Button)pagerRow.Cells[0].FindControl("btnNum" + count);
            numButton.Visible = true;
            if (i == pageIndex) {
                numButton.Text = str;
                numButton.Enabled = false;
            }
            else {
                numButton.Text = str;
                numButton.CommandArgument = str;
            }
        }
        if (pageCount > last) {
            btnNextList.Visible = true;

            int t = last + 1;
            btnNextList.CommandArgument = t.ToString();
            btnNextList.Text = "" + pageButtonCount + "";

            btnLast.Visible = true;
            lLast.Visible = true;

            btnLast.Text = pageCount.ToString();
        }
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<body>
    <form id="form1" runat="server">
        <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" DataSourceID="SqlDataSource1" AllowPaging="True" PageSize="3" OnDataBound="GridView1_DataBound">
            <Columns>
                <asp:BoundField DataField="fname" HeaderText="fname"/>
                <asp:BoundField DataField="lname" HeaderText="lname"/>
                <asp:BoundField DataField="hire_date" HeaderText="hire_date"/>
            </Columns>
            <PagerSettings PageButtonCount="4"/>
            <PagerTemplate>
          <table width="100%">
            <tr>
              <td>
                  <asp:Button ID="btnPrevList" runat="server" CommandName="Page" CausesValidation="false"/>
                  &nbsp;
                  <asp:Button ID="btnFirst" runat="server" CommandName="Page" CommandArgument="First" CausesValidation="false" Text="1"/>
                  <asp:Literal ID="lFirst" runat="server" Text="... " />
                  <asp:Button ID="btnNum1" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum2" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum3" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum4" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum5" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum6" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum7" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum8" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum9" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Button ID="btnNum10" runat="server" CommandName="Page" CausesValidation="false"/>
                  <asp:Literal ID="lLast" runat="server" Text=" ..." />
                  <asp:Button ID="btnLast" runat="server" CommandName="Page" CommandArgument="Last" CausesValidation="false"/>
                  &nbsp;
                  <asp:Button ID="btnNextList" runat="server" CommandName="Page" CausesValidation="false"/>
              </td>
               <td>
                  <asp:dropdownlist id="DropDownList1"
                      autopostback="true"
                      onselectedindexchanged="DropDownList1_SelectedIndexChanged" 
                      runat="server"/>
               </td>
            </tr>
            <tr>
              <td>&nbsp;
                   <asp:label id="TotalPagesLabel" runat="server" Font-Bold="true"/> 
                  <asp:label id="PageNumberLabel" runat="server" Font-Bold="true"/> 
              </td>
              <td>
                <asp:linkbutton id="FirstButton" text="<<"
                  CommandName="Page" CommandArgument="First"
                  runat="Server" CausesValidation="false"/>
                <asp:linkbutton id="PreviousButton" text="<"
                  CommandName="Page" CommandArgument="Prev"
                  runat="Server" CausesValidation="false"/>
                <asp:linkbutton id="NextButton" text=">"
                  CommandName="Page" CommandArgument="Next"
                  runat="Server" CausesValidation="false"/> 
                <asp:linkbutton id="LastButton" text=">>"
                  CommandName="Page" CommandArgument="Last"
                  runat="Server" CausesValidation="false"/>
              </td>
            </tr>
          </table> 
            </PagerTemplate>
        </asp:GridView>
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" 
            ConnectionString="<%$ ConnectionStrings:pubsConnectionString %>"
            SelectCommand="SELECT [emp_id], [fname], [lname], [hire_date] FROM [employee]" />
    </form>
</body>
</html>
