<%@ Page Language="C#" %>
<script runat="server">
    protected void Button1_Click(object sender, EventArgs e)
    {
        MultiView1.ActiveViewIndex = 1;
    }
    protected void DetailsView1_ItemInserted(object sender, DetailsViewInsertedEventArgs e)
    {
        if (e.Exception != null) {
            lblErrorMessage.Visible = true;
            lblErrorMessage.Text = e.Exception.Message;
            e.ExceptionHandled = true;
        }
        else {
            MultiView1.ActiveViewIndex = 0;
            lblErrorMessage.Visible = false;
        }
    }
    protected void DetailsView1_ItemCommand(object sender, DetailsViewCommandEventArgs e)
    {
        if (e.CommandName.Equals("Cancel")) {
            MultiView1.ActiveViewIndex = 0;
            lblErrorMessage.Visible = false;
        }
    }
</script>
<html xmlns="http://www.w3.org/1999/xhtml" >
<body>
    <form id="form2" runat="server">
        <asp:MultiView ID="MultiView1" runat="server" ActiveViewIndex="0">
            <asp:View ID="View1" runat="server">
    <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" DataKeyNames="id"
        DataSourceID="SqlDataSource1" EmptyDataText="There are no data records to display.">
        <Columns>
            <asp:TemplateField ShowHeader="False">
                <ItemTemplate>
                    <asp:LinkButton ID="LinkButton1" runat="server" CausesValidation="False" CommandName="Edit" Text=""/>&nbsp;
                    <asp:LinkButton ID="LinkButton2" runat="server" CausesValidation="False" CommandName="Delete" Text=""/>
                </ItemTemplate>
                <EditItemTemplate>
                    <asp:LinkButton ID="LinkButton1" runat="server" CausesValidation="True" CommandName="Update" Text=""/>&nbsp;
                    <asp:LinkButton ID="LinkButton2" runat="server" CausesValidation="False" CommandName="Cancel" Text=""/>
                </EditItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="id" SortExpression="id">
                <ItemTemplate>
                    <asp:Label ID="Label2" runat="server" Text='<%# Bind("id") %>'/>
                </ItemTemplate>
                <EditItemTemplate>
                    <asp:Label ID="Label1" runat="server" Text='<%# Eval("id") %>'/>
                </EditItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="data1" SortExpression="data1">
                <ItemTemplate>
                    <asp:Label ID="Label1" runat="server" Text='<%# Bind("data1") %>'/>
                </ItemTemplate>
                <EditItemTemplate>
                    <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("data1") %>'/>
                </EditItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField HeaderText="data2" SortExpression="data2">
                <ItemTemplate>
                    <asp:Label ID="Label3" runat="server" Text='<%# Bind("data2") %>'/>
                </ItemTemplate>
                <EditItemTemplate>
                    <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("data2") %>'/>
                </EditItemTemplate>
            </asp:TemplateField>
        </Columns>
    </asp:GridView>
    <asp:Button ID="Button1" runat="server" OnClick="Button1_Click" Text="߰" />
            </asp:View>
            <asp:View ID="View2" runat="server">
    <asp:DetailsView ID="DetailsView1" runat="server" AutoGenerateRows="false"
        DataSourceID="SqlDataSource1" DefaultMode="Insert" OnItemCommand="DetailsView1_ItemCommand" OnItemInserted="DetailsView1_ItemInserted">
        <Fields>
            <asp:TemplateField>
                <InsertItemTemplate>
                    <table cellpadding=0 cellspacing=0>
                        <tr>
                            <td width="70">
                                <strong>id </strong>
                                </td>
                            <td>
        <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("id") %>'/>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <strong>data1 </strong>
                            </td>
                            <td>
        <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("data1") %>'/>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <strong>data2 </strong>
                            </td>
                            <td>
        <asp:TextBox ID="TextBox3" runat="server" Text='<%# Bind("data2") %>'/>
                            </td>
                        </tr>
                    </table>
                </InsertItemTemplate>
            </asp:TemplateField>
            <asp:TemplateField ShowHeader="False">
                <InsertItemTemplate>
                    <asp:LinkButton ID="LinkButton1" runat="server" CausesValidation="True" CommandName="Insert" Text="߰"/>
                    <asp:LinkButton ID="LinkButton2" runat="server" CausesValidation="False" CommandName="Cancel" Text=""/>
                </InsertItemTemplate>
            </asp:TemplateField>
        </Fields>
    </asp:DetailsView>
    <asp:Label ID="lblErrorMessage" runat="server" ForeColor="Red" Visible="False"/>
            </asp:View>
        </asp:MultiView>
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" 
            ConnectionString="<%$ ConnectionStrings:DatabaseConnectionString1 %>"
            ProviderName="<%$ ConnectionStrings:DatabaseConnectionString1.ProviderName %>"
            SelectCommand="SELECT [id], [data1], [data2] FROM [TestTable]" 
            DeleteCommand="DELETE FROM [TestTable] WHERE [id] = @original_id" 
            InsertCommand="INSERT INTO [TestTable] ([id], [data1], [data2]) VALUES (@id, @data1, @data2)"
            UpdateCommand="UPDATE [TestTable] SET [data1] = @data1, [data2] = @data2 WHERE [id] = @original_id">
            <InsertParameters>
                <asp:Parameter Name="id" Type="String" />
                <asp:Parameter Name="data1" Type="String" />
                <asp:Parameter Name="data2" Type="String" />
            </InsertParameters>
            <UpdateParameters>
                <asp:Parameter Name="data1" Type="String" />
                <asp:Parameter Name="data2" Type="String" />
                <asp:Parameter Name="original_id" Type="String" />
            </UpdateParameters>
            <DeleteParameters>
                <asp:Parameter Name="original_id" Type="String" />
            </DeleteParameters>
        </asp:SqlDataSource>
    </form>
</body>
</html>