<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<script runat="server">

    //DataSourceSelectArguments args;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
            BindData(null);

    }

    void BindData(string sortExpression)
    {
        IDataSource ds = (IDataSource)ObjectDataSource1;
        ObjectDataSourceView odv = (ObjectDataSourceView)ds.GetView(String.Empty);;

        DataSourceSelectArguments largs = new DataSourceSelectArguments();
        if (DataGrid1.CurrentPageIndex == -1)
            largs.StartRowIndex = 0;
        else
            largs.StartRowIndex = DataGrid1.CurrentPageIndex * DataGrid1.PageSize;
        largs.MaximumRows = DataGrid1.PageSize;
        largs.RetrieveTotalRowCount = true;

        string vse = (string)ViewState["sortExpression"];
        if (sortExpression != null) {
            if (vse != null && vse.StartsWith(sortExpression)) {
                if (vse.Equals(sortExpression)) {
                    largs.SortExpression = sortExpression + " desc";
                    ViewState["sortExpression"] = sortExpression + " desc";
                }
                else {
                    largs.SortExpression = sortExpression;
                    ViewState["sortExpression"] = sortExpression;
                }
            }
            else {
                largs.SortExpression = sortExpression;
                ViewState["sortExpression"] = sortExpression;
            }
        }
        else if (vse != null)
            largs.SortExpression = vse;
        
        DataGrid1.DataSource = odv.Select(largs);
        DataGrid1.VirtualItemCount = largs.TotalRowCount;
        DataGrid1.DataBind();
    }

    /*
    void BindData(string sortExpression)
    {
        IDataSource ds = (IDataSource)ObjectDataSource1;
        DataSourceView dv = ds.GetView(String.Empty);
        ObjectDataSourceView odv = (ObjectDataSourceView)dv;

        args = new DataSourceSelectArguments();
        if (DataGrid1.CurrentPageIndex == -1)
            args.StartRowIndex = 0;
        else
            args.StartRowIndex = DataGrid1.CurrentPageIndex * DataGrid1.PageSize;
        args.MaximumRows = DataGrid1.PageSize;
        
        args.RetrieveTotalRowCount = true;
        string vse = (string)ViewState["sortExpression"];
        if (sortExpression != null) {
            if (vse != null && vse.StartsWith(sortExpression)) {
                if (vse.Equals(sortExpression)) {
                    args.SortExpression = sortExpression + " desc";
                    ViewState["sortExpression"] = sortExpression + " desc";
                }
                else {
                    args.SortExpression = sortExpression;
                    ViewState["sortExpression"] = sortExpression;
                }
            }
            else {
                args.SortExpression = sortExpression;
                ViewState["sortExpression"] = sortExpression;
            }
        }
        else if (vse != null)
            args.SortExpression = vse;

        DataSourceViewSelectCallback callback = new DataSourceViewSelectCallback(BindDataSource);
        dv.Select(args, callback);
    }
    
    void BindDataSource(IEnumerable data) {
        DataGrid1.DataSource = data;
        DataGrid1.VirtualItemCount = args.TotalRowCount;
        DataGrid1.DataBind();
    }
     * */

    protected void DataGrid1_PageIndexChanged(object source, DataGridPageChangedEventArgs e)
    {
        DataGrid1.CurrentPageIndex = e.NewPageIndex;
        BindData(null);
    }

    protected void DataGrid1_SortCommand(object source, DataGridSortCommandEventArgs e)
    {
        BindData(e.SortExpression);
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
        <asp:DataGrid ID="DataGrid1" runat="server" 
        AllowPaging="true" AllowSorting="true"
        AllowCustomPaging="True" PagerStyle-Mode="NumericPages"
        OnPageIndexChanged="DataGrid1_PageIndexChanged" OnSortCommand="DataGrid1_SortCommand" />

        <asp:ObjectDataSource ID="ObjectDataSource1" runat="server" 
            TypeName="SelectExam3" EnablePaging="True" 
            SelectCountMethod="TotalCount" SelectMethod="Select" 
            SortParameterName="sortExpression">
        </asp:ObjectDataSource>
    </form>
</body>
</html>
