<%@ Page Language="C#" %>
<script runat="server">
    protected void GridView1_PageIndexChanged(object sender, EventArgs e)
    {
        GridView1.SelectedIndex = -1;
    }

    protected void btnAppend_Click(object sender, EventArgs e)
    {
        phStateSelect.Visible = false;
        GridView1.SelectedIndex = -1;
        GridView1.Visible = false;
        DetailsView1.ChangeMode(DetailsViewMode.Insert);
        DetailsView1.AutoGenerateInsertButton = true;
        btnAppend.Visible = false;

        this.ViewState["GridViewPageIndex"] = GridView1.PageIndex;
        GridView1.PageIndex = GridView1.PageCount - 1;
        GridView1.DataBind();
    }

    protected void DetailsView1_ItemInserted(object sender, DetailsViewInsertedEventArgs e)
    {
        phStateSelect.Visible = true;
        GridView1.Visible = true;
        DetailsView1.ChangeMode(DetailsViewMode.ReadOnly);
        DetailsView1.AutoGenerateInsertButton = false;
        btnAppend.Visible = true;

        int pageIndex;
        if (GridView1.Rows.Count == GridView1.PageSize)
            pageIndex = GridView1.PageIndex + 1;
        GridView1.DataBind();
        this.ViewState.Remove("GridViewPageIndex");
    }

    protected void DetailsView1_ItemCommand(object sender, DetailsViewCommandEventArgs e)
    {
        if (e.CommandName.Equals("Cancel") 
            && DetailsView1.CurrentMode == DetailsViewMode.Insert) {
            phStateSelect.Visible = true;
            GridView1.Visible = true;
            DetailsView1.ChangeMode(DetailsViewMode.ReadOnly);
            DetailsView1.AutoGenerateInsertButton = false;
            btnAppend.Visible = true;

            GridView1.PageIndex = (int)ViewState["GridViewPageIndex"];
            GridView1.DataBind();
            this.ViewState.Remove("GridViewPageIndex");
        }
    }

    protected void ObjectDataSource3_Deleted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        // ڵ尡  DetailsView1  ͸ 
        // εϴٰ  ߻Ѵ.
        if ((int)e.ReturnValue > 0) {
            GridView1.SelectedIndex = -1;
            GridView1.DataBind();
        }
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<body>
    <form id="form1" runat="server">
        <asp:PlaceHolder ID="phStateSelect" runat="server">
            Stete  :
            <asp:DropDownList ID="DropDownList1" runat="server" DataSourceID="ObjectDataSource2" 
                AppendDataBoundItems="True" AutoPostBack="True">
                <asp:ListItem Value="*">κ</asp:ListItem>
            </asp:DropDownList>
        </asp:PlaceHolder>
        <asp:ObjectDataSource ID="ObjectDataSource2" runat="server" 
            SelectMethod="GetStates" TypeName="AuthorsComponent"/>
        <br />
        <table border="0" >
            <tr>
                <td valign="top">
    <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" 
        DataSourceID="ObjectDataSource1" DataKeyNames="Au_id" AllowPaging="True" 
        OnPageIndexChanged="GridView1_PageIndexChanged" AllowSorting="True">
        <Columns>
            <asp:CommandField ShowSelectButton="True" ShowEditButton="True" />
            <asp:BoundField DataField="Au_id" HeaderText="Au_id" SortExpression="Au_id" />
            <asp:BoundField DataField="Au_fname" HeaderText="Au_fname" SortExpression="Au_fname" />
            <asp:BoundField DataField="Au_lname" HeaderText="Au_lname" SortExpression="Au_lname" />
            <asp:BoundField DataField="State" HeaderText="State" SortExpression="State" />
        </Columns>
    </asp:GridView>
    <asp:ObjectDataSource ID="ObjectDataSource1" runat="server" 
        SelectMethod="GetAuthorsByState" UpdateMethod="UpdateAuthor"
        TypeName="AuthorsComponent" SelectCountMethod="GetRowCount" 
        EnablePaging="true" SortParameterName="sortExpression">
        <SelectParameters>
            <asp:ControlParameter ControlID="DropDownList1" DefaultValue="*" Name="state" PropertyName="SelectedValue"
                Type="String" />
            <asp:Parameter Name="sortExpression" Type="String" />
        </SelectParameters>
    </asp:ObjectDataSource>
                </td>
                <td valign="top">
    <asp:DetailsView ID="DetailsView1" runat="server" DataSourceID="ObjectDataSource3"
        Width="230px" AutoGenerateRows="False" AutoGenerateDeleteButton="True" 
        AutoGenerateEditButton="True" OnItemInserted="DetailsView1_ItemInserted" 
        OnItemCommand="DetailsView1_ItemCommand" DataKeyNames="Au_id">
        <Fields>
            <asp:BoundField DataField="Au_id" HeaderText="Au_id" ReadOnly="True" />
            <asp:TemplateField HeaderText="Name">
                <ItemTemplate>
                    <%# Eval("FullName") %>
                </ItemTemplate>
                <EditItemTemplate>
                    first name <asp:TextBox ID="txtFname" runat="server" Text='<%# Bind("Au_fname") %>' />,
                    last name <asp:TextBox ID="txtLname" runat="server" Text='<%# Bind("Au_lname") %>' />
                </EditItemTemplate>
                <InsertItemTemplate>
                    first name <asp:TextBox ID="txtFname" runat="server" Text='<%# Bind("Au_fname") %>' />,
                    last name <asp:TextBox ID="txtLname" runat="server" Text='<%# Bind("Au_lname") %>' />
                </InsertItemTemplate>
            </asp:TemplateField>
            <asp:BoundField DataField="Phone" HeaderText="Phone" />
            <asp:BoundField DataField="Zip" HeaderText="Zip" />
            <asp:BoundField DataField="Address" HeaderText="Address" />
            <asp:BoundField DataField="City" HeaderText="City" />
            <asp:BoundField DataField="State" HeaderText="State" />
            <asp:CheckBoxField DataField="Contract" HeaderText="Contract" />
        </Fields>
    </asp:DetailsView>
    <asp:ObjectDataSource ID="ObjectDataSource3" runat="server" 
        TypeName="AuthorsComponent" SelectMethod="GetAuthor" 
        UpdateMethod="UpdateAuthor" InsertMethod="InsertAuthor"
        DeleteMethod="DeleteAuthor" DataObjectTypeName="AuthorClass" OnDeleted="ObjectDataSource3_Deleted" >
        <SelectParameters>
            <asp:ControlParameter ControlID="GridView1" Name="au_id"
                PropertyName="SelectedValue" />
        </SelectParameters>
    </asp:ObjectDataSource>
                </td>
            </tr>
        </table>
        <asp:Button ID="btnAppend" runat="server" Text=" ߰" OnClick="btnAppend_Click" />
    </form>
</body>
</html>
