using System;
using System.Text.RegularExpressions;

public class DataObject
{
    private string _keyField;
    private string _field1;
    private string _field2;
    private bool _processValidation;

    public string KeyField {
        get { return _keyField; }
        set {
            string tv = value;
            if (_processValidation) {
                if (tv == null)
                    throw new ArgumentNullException("KeyField null Ҽ ϴ.");

                Regex rx = new Regex(@"\d{1,4}");
                if (!rx.IsMatch(tv))
                    throw new ArgumentNullException("KeyField  Է  ֽϴ.");

                tv = int.Parse(tv).ToString("0000");
            }
            _keyField = tv;
        }
    }
    public string Field1 {
        get { return _field1; }
        set { _field1 = value; }
    }
    public string Field2 {
        get { return _field2; }
        set { _field2 = value; }
    }
    public string CombinedField {
        get { return _field1 + "(" + _field2 + ")"; }
    }
    public bool ProcessValidation {
        get { return _processValidation; }
        set { _processValidation = value; }
    }
    string _original_keyField;
    public string original_keyField
    {
        get { return _original_keyField; }
        set { _original_keyField = value; }
    }

    public DataObject() {
        _processValidation = true;
    }
    public DataObject(string keyField, string field1, string field2) {
        _processValidation = true;
        this.KeyField = keyField;
        this.Field1 = field1;
        this.Field2 = field2;
    }
    public DataObject(string keyField, string field1, string field2, bool processValidation) {
        _processValidation = processValidation;
        this.KeyField = keyField;
        this.Field1 = field1;
        this.Field2 = field2;
    }
}
