using System;
using System.Collections.Generic;

public class DataObjectComparer : IComparer<DataObject>
{
    private string _sortColumn;
    private bool _reverse;

    public DataObjectComparer(string sortExpression) {
        _reverse = sortExpression.ToLowerInvariant().EndsWith(" desc");
        if (_reverse)
            _sortColumn = sortExpression.Substring(0, sortExpression.Length - 5);
        else
            _sortColumn = sortExpression;
    }

    public int Compare(DataObject a, DataObject b) {
        int retVal = 0;
        switch (_sortColumn) {
            case "keyField":
                retVal = String.Compare(a.KeyField, b.KeyField, StringComparison.InvariantCultureIgnoreCase);
                break;
            case "field1":
                retVal = String.Compare(a.Field1, b.Field1, StringComparison.InvariantCultureIgnoreCase);
                break;
            case "field2":
                retVal = String.Compare(a.Field2, b.Field2, StringComparison.InvariantCultureIgnoreCase);
                break;
        }
        return (retVal * (_reverse ? -1 : 1));
    }
}