using System;
using System.Web;
using System.Data;
using System.Collections;
using System.Collections.Specialized;
using System.Collections.Generic;

public class DataObjectExam1
{
    HttpContext _context;
    int _recordCount;

    public DataObjectExam1() {
        _context = HttpContext.Current;
        _recordCount = 1000;
        _context.Response.Write("DataObjectExam1 Ŭ ⺻  <br>");
	}

    public List<DataObject> Select() {
        _context.Response.Write("Select() <br>");
        return Select(int.MaxValue, 0, string.Empty);
    }

    public List<DataObject> Select(string sortExpression) {
        _context.Response.Write("Select(string sortExpression) <br>");
        return Select(int.MaxValue, 0, sortExpression);
    }

    public List<DataObject> Select(int maximumRows, int startRowIndex) {
        _context.Response.Write("Select(int maximumRows, int startRowIndex) <br>");
        return Select(maximumRows, startRowIndex, string.Empty);
    }

    public List<DataObject> Select(int recordCount) {
        _context.Response.Write("Select(int recordCount) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(int.MaxValue, 0, string.Empty);
    }

    public List<DataObject> Select(int recordCount, string sortExpression) {
        _context.Response.Write("Select(int recordCount, string sortExpression) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(sortExpression);
    }

    public List<DataObject> Select(int recordCount, int maximumRows, int startRowIndex) {
        _context.Response.Write("Select(int recordCount, int maximumRows, int startRowIndex) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(maximumRows, startRowIndex);
    }

    public List<DataObject> Select(int recordCount, int maximumRows, int startRowIndex, string sortExpression) {
        _context.Response.Write("Select(int recordCount, int maximumRows, int startRowIndex, string sortExpression) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(maximumRows, startRowIndex, sortExpression);
    }

    public List<DataObject> Select(int maximumRows, int startRowIndex, string sortExpression) {
        _context.Response.Write("Select(int maximumRows, int startRowIndex, string sortExpression) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>maximumRows="
            + maximumRows + ", startRowIndex=" + startRowIndex
            + ", sortExpression=" + sortExpression + "</i><br>");

        List<DataObject> dataList = new List<DataObject>();
        List<DataObject> resultDataList = new List<DataObject>();

        byte asciiAscNo = Convert.ToByte('a');
        byte asciiDescNo = Convert.ToByte('Z');
        int totalCount = _recordCount;

        for (int i = 0; i < totalCount; i++) {
            dataList.Add(new DataObject(i.ToString("0000"),
                "data1-" + Convert.ToChar(asciiAscNo) + "-" + i.ToString("0000"),
                "data2-" + Convert.ToChar(asciiDescNo) + "-" + i.ToString("0000")));
            asciiAscNo++;
            if (asciiAscNo > Convert.ToByte('z'))
                asciiAscNo = Convert.ToByte('a');
            asciiDescNo--;
            if (asciiDescNo < Convert.ToByte('A'))
                asciiDescNo = Convert.ToByte('Z');
        }

        if (maximumRows == int.MaxValue && sortExpression == string.Empty)
            resultDataList = dataList;
        else {
            if (sortExpression != string.Empty)
                dataList.Sort(new DataObjectComparer(sortExpression));

            int i = startRowIndex;
            int readCount = 0;
            while (readCount < maximumRows && i < totalCount) {
                resultDataList.Add(dataList[i]);
                i++;
                readCount++;
            }
        }

        return resultDataList;
    }

    public int TotalCount() {
        _context.Response.Write("TotalCount() ޼ <br>");
        return _recordCount;
    }

    public int TotalCount(int recordCount) {
        _context.Response.Write("TotalCount(int recordCount) <br>");
        return TotalCount();
    }

    public int Delete() {
        _context.Response.Write("Delete() <br>");
        return 0;
    }

    public int Delete(string original_keyField) {
        _context.Response.Write("Delete(string original_keyField)  <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>original_keyField="
            + original_keyField + "</i><br>");

        return 0;
    }

    public int Delete(string original_keyField, out string deleteMessage)
    {
        _context.Response.Write("Delete(string original_keyField, out string deleteMessage) <br>");
        deleteMessage = "Delete  ڿ";
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write(
            "<i>original_keyField=" + original_keyField
            + ", deleteMessage=" + deleteMessage + "</i><br>");

        return 0;
    }

    public int Delete(string original_keyField, string original_field1, string original_field2)
    {
        _context.Response.Write("Delete(string original_keyField, string original_field1, string original_field2)  <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write(
            "<i>original_keyField="
            + ", original_field1=" + original_field1
            + ", original_field2=" + original_field2
            + original_keyField + "</i><br>");

        return 0;
    }

    public int Delete(string original_keyField, string original_field1, string original_field2, out string deleteMessage)
    {
        _context.Response.Write("Delete(string original_keyField, string original_field1, string original_field2, out string deleteMessage) <br>");
        deleteMessage = "Delete  ڿ";
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write(
            "<i>original_keyField=" + original_keyField
            + ", original_field1=" + original_field1
            + ", original_field2=" + original_field2
            + ", deleteMessage=" + deleteMessage + "</i><br>");

        return 0;
    }

    public string Update(string keyField, string field1, string field2) {
        _context.Response.Write("Update(string keyField, string field1, string field2) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>"
                + "keyField=" + keyField + ", field1=" + field1 
                + ", field2=" + field2 + "</i><br>");

        return "͸ ߽ϴ.";
    }

    public int Update(string original_keyField, string keyField, string field1, string field2) {
        _context.Response.Write("Update(string original_keyField, string keyField, string field1, string field2) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>original_keyField="
            + original_keyField + ", keyField=" + keyField
            + ", field1=" + field1 + ", field2=" + field2 + "</i><br>");

        return 0;
    }

    public int Update(string original_keyField, string original_field1, string original_field2, string keyField, string field1, string field2)
    {
        _context.Response.Write("Update(string original_keyField, string original_field1, string original_field2, string keyField, string field1, string field2) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write(
            "<i>original_keyField=" + original_keyField
            + ", original_field1=" + original_field1
            + ", original_field2=" + original_field2
            + ", keyField=" + keyField
            + ", field1=" + field1 + ", field2=" + field2 + "</i><br>");

        return 0;
    }

    public int Update(string original_keyField, string keyField, string field1, string field2, out string updateMessage)
    {
        _context.Response.Write("Update(string original_keyField, string keyField, string field1, string field2, out string updateMessage) <br>");
        updateMessage = "Update  ڿ";
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write(
            "<i>original_keyField=" + original_keyField
            + ", keyField=" + keyField
            + ", field1=" + field1 + ", field2=" + field2
            + ", updateMessage=" + updateMessage + "</i><br>");

        return 0;
    }

    public int Update(string original_keyField, string original_field1, string original_field2, string keyField, string field1, string field2, out string updateMessage)
    {
        _context.Response.Write("Update(string original_keyField, string original_field1, string original_field2, string keyField, string field1, string field2, out string updateMessage) <br>");
        updateMessage = "Update  ڿ";
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write(
            "<i>original_keyField=" + original_keyField
            + ", original_field1=" + original_field1
            + ", original_field2=" + original_field2
            + ", keyField=" + keyField
            + ", field1=" + field1 + ", field2=" + field2
            + ", updateMessage=" + updateMessage + "</i><br>");

        return 0;
    }
}
