using System;
using System.Web;
using System.Data;
using System.Collections;
using System.Collections.Specialized;

public class UpdateDeleteExam1
{
    HttpContext _context;
    int _recordCount;

    public UpdateDeleteExam1() {
        _context = HttpContext.Current;
        _recordCount = 1000;
        _context.Response.Write("UpdateDeleteExam1 Ŭ ⺻  <br>");
	}

    public DataSet Select() {
        _context.Response.Write("Select() <br>");
        return Select(int.MaxValue, 0, string.Empty);
    }

    public DataSet Select(string sortExpression) {
        _context.Response.Write("Select(string sortExpression) <br>");
        return Select(int.MaxValue, 0, sortExpression);
    }

    public DataSet Select(int maximumRows, int startRowIndex) {
        _context.Response.Write("Select(int maximumRows, int startRowIndex) <br>");
        return Select(maximumRows, startRowIndex, string.Empty);
    }

    public DataSet Select(int recordCount) {
        _context.Response.Write("Select(int recordCount) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(int.MaxValue, 0, string.Empty);
    }

    public DataSet Select(int recordCount, string sortExpression) {
        _context.Response.Write("Select(int recordCount, string sortExpression) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(sortExpression);
    }

    public DataSet Select(int recordCount, int maximumRows, int startRowIndex) {
        _context.Response.Write("Select(int recordCount, int maximumRows, int startRowIndex) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(maximumRows, startRowIndex);
    }

    public DataSet Select(int recordCount, int maximumRows, int startRowIndex, string sortExpression) {
        _context.Response.Write("Select(int recordCount, int maximumRows, int startRowIndex, string sortExpression) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>recordCount="
            + recordCount + "</i><br>");

        _recordCount = recordCount;
        return Select(maximumRows, startRowIndex, sortExpression);
    }

    public DataSet Select(int maximumRows, int startRowIndex, string sortExpression) {
        _context.Response.Write("Select(int maximumRows, int startRowIndex, string sortExpression) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>maximumRows="
            + maximumRows + ", startRowIndex=" + startRowIndex
            + ", sortExpression=" + sortExpression + "</i><br>");

        DataSet ds = new DataSet();
        DataTable dt = new DataTable();
        DataTable resultDT;

        dt.Columns.Add("keyField", typeof(string)).Unique = true;
        dt.Columns.Add("field1", typeof(string));
        dt.Columns.Add("field2", typeof(string));

        byte asciiAscNo = Convert.ToByte('a');
        byte asciiDescNo = Convert.ToByte('Z');
        int totalCount = _recordCount;

        for (int i = 0; i < totalCount; i++)
        {
            dt.Rows.Add(new object[] { i.ToString("0000"), 
                "data1-" + Convert.ToChar(asciiAscNo) + "-" + i.ToString("0000"), 
                "data2-" + Convert.ToChar(asciiDescNo) + "-" + i.ToString("0000") });
            asciiAscNo++;
            if (asciiAscNo > Convert.ToByte('z'))
                asciiAscNo = Convert.ToByte('a');
            asciiDescNo--;
            if (asciiDescNo < Convert.ToByte('A'))
                asciiDescNo = Convert.ToByte('Z');
        }

        if (maximumRows == int.MaxValue && sortExpression == string.Empty)
            resultDT = dt;
        else
        {
            resultDT = dt.Clone();
            DataView dv = dt.DefaultView;
            if (sortExpression != string.Empty)
                dv.Sort = sortExpression;

            int i = startRowIndex;
            int readCount = 0;
            while (readCount < maximumRows && i < totalCount)
            {
                resultDT.Rows.Add(dv[i]["keyField"], dv[i]["field1"], dv[i]["field2"]);
                i++;
                readCount++;
            }
        }

        ds.Tables.Add(resultDT);
        return ds;
    }

    public int TotalCount() {
        _context.Response.Write("TotalCount() ޼ <br>");
        return _recordCount;
    }

    public int TotalCount(int recordCount) {
        _context.Response.Write("TotalCount(int recordCount) <br>");
        return TotalCount();
    }

    public int Delete() {
        _context.Response.Write("Delete() <br>");
        return 0;
    }

    public string Update(string keyField, string field1, string field2) {
        _context.Response.Write("Update(string keyField, string field1, string field2) <br>");
        _context.Response.Write("&nbsp;&nbsp;&nbsp;");
        _context.Response.Write("<i>"
                + "keyField=" + keyField + ", field1=" + field1 
                + ", field2=" + field2 + "</i><br>");

        return "͸ ߽ϴ.";
    }
}
