using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;
using System.Configuration;

public class BoardInfo
{
    private string _connStr;

	public BoardInfo() {
        _connStr = ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString;
	}

    public List<BoardClass> GetBoardList()
    {
        string queryString = "SELECT * FROM [boardInfo]";
        SqlConnection conn = new SqlConnection(_connStr);
        SqlCommand cmd = new SqlCommand();
        SqlDataReader sdr;
        cmd.Connection = conn;
        cmd.CommandText = queryString;

        conn.Open();
        sdr = cmd.ExecuteReader();
        List<BoardClass> boards = new List<BoardClass>();
        BoardClass board;
        while (sdr.Read()) {
            board = new BoardClass((int)sdr["no"],
                (string)sdr["subject"], (string)sdr["tableName"],
                sdr["allowRoles"] == DBNull.Value? "" : (string)sdr["allowRoles"],
                sdr["allowUsers"] == DBNull.Value ? "" : (string)sdr["allowUsers"]);
            boards.Add(board);
        }
        sdr.Close();
        conn.Close();

        return boards;
    }

    public BoardClass GetBoard(int no)
    {
        if (no == 0)
            return null;
        else
            return new BoardClass(no, _connStr);
    }

    public void UpdateBoard(int no,
        string subject, string tableName,
        string allowRoles, string allowUsers)
    {
        BoardClass board = new BoardClass(no, 
            subject, tableName, allowRoles, allowUsers);
        board.ConnectionString = _connStr;
        board.Update();
    }

    public int InsertBoard(string subject, 
        string tableName, string allowRoles, 
        string allowUsers)
    {
        BoardClass board = new BoardClass();
        board.No = -1;
        board.Subject = subject;
        board.TableName = tableName;
        board.AllowUsers = allowUsers;
        board.AllowRoles = allowRoles;
        board.ConnectionString = _connStr;
        return board.Insert();
    }
}
