<%@ Page Language="C#" MasterPageFile="~/MasterPage.master" Title="ڰ" %>
<script runat="server">
    protected void dvUser_DataBound(object sender, EventArgs e)
    {
        CheckBoxList cblRoles = (CheckBoxList)dvUser.FindControl("cblRoles");
        if (cblRoles != null) {
            cblRoles.DataSource = Roles.GetAllRoles();
            cblRoles.DataBind();
            foreach (string role in Roles.GetRolesForUser((string)gvUasers.SelectedValue)) { 
                ListItem item = cblRoles.Items.FindByText(role);
                if (item != null)
                    item.Selected = true;
            }
        }
    }

    protected void dvUser_ItemUpdating(object sender, DetailsViewUpdateEventArgs e)
    {
        string userName = (string)gvUasers.SelectedValue;
        CheckBoxList cblRoles = (CheckBoxList)dvUser.FindControl("cblRoles");
        if (cblRoles != null) {
            foreach (ListItem item in cblRoles.Items) {
                if (item.Selected && !Roles.IsUserInRole(userName, item.Text))
                    Roles.AddUserToRole(userName, item.Text);
                else if (!item.Selected && Roles.IsUserInRole(userName, item.Text))
                    Roles.RemoveUserFromRole(userName, item.Text);
            }
        }
        MembershipUser user = Membership.GetUser(userName);
        user.Email = (string)e.NewValues["Email"];
        user.Comment = (string)e.NewValues["Comment"];
        user.IsApproved = (bool)e.NewValues["IsApproved"];
        Membership.UpdateUser(user);

        e.Cancel = true;
        dvUser.ChangeMode(DetailsViewMode.ReadOnly);
    }

    protected void dvUser_ItemDeleted(object sender, DetailsViewDeletedEventArgs e)
    {
        gvUasers.SelectedIndex = -1;
        gvUasers.DataBind();
    }
</script>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <table>
        <tr>
            <td valign="top">
    <asp:GridView ID="gvUasers" runat="server" DataSourceID="ObjectDataSource1"
        DataKeyNames="UserName" AllowPaging="True" AutoGenerateColumns="False">
        <Columns>
            <asp:CommandField ShowSelectButton="True" />
            <asp:CheckBoxField DataField="IsApproved" HeaderText="IsApproved" />
            <asp:BoundField DataField="UserName" HeaderText="UserName" />
        </Columns>
    </asp:GridView>
            </td>
            <td valign="top">
    <asp:DetailsView ID="dvUser" runat="server" DataSourceID="ObjectDataSource2" Width="125px" AutoGenerateRows="False" AutoGenerateEditButton="True" AutoGenerateDeleteButton="True" OnDataBound="dvUser_DataBound" OnItemUpdating="dvUser_ItemUpdating" OnItemDeleted="dvUser_ItemDeleted">
        <Fields>
            <asp:BoundField DataField="UserName" HeaderText="UserName" ReadOnly="True" />
            <asp:BoundField DataField="Email" HeaderText="Email" />
            <asp:BoundField DataField="Comment" HeaderText="Comment"/>
            <asp:CheckBoxField DataField="IsApproved" HeaderText="IsApproved" />
            <asp:CheckBoxField DataField="IsOnline" HeaderText="IsOnline" ReadOnly="True" />
            <asp:CheckBoxField DataField="IsLockedOut" HeaderText="IsLockedOut" ReadOnly="True" />
            <asp:TemplateField HeaderText="">
                <ItemTemplate>
                    <asp:CheckBoxList ID="cblRoles" runat="server" Enabled="false" />
                </ItemTemplate>
                <EditItemTemplate>
                    <asp:CheckBoxList ID="cblRoles" runat="server" />
                </EditItemTemplate>
            </asp:TemplateField>
        </Fields>
    </asp:DetailsView>
            </td>
        </tr>
    </table>
    <asp:ObjectDataSource ID="ObjectDataSource1" runat="server" 
        TypeName="System.Web.Security.Membership"
        SelectMethod="GetAllUsers" >
    </asp:ObjectDataSource>
    <asp:ObjectDataSource ID="ObjectDataSource2" runat="server" 
        TypeName="System.Web.Security.Membership"
        SelectMethod="GetUser" DeleteMethod="DeleteUser">
        <SelectParameters>
            <asp:ControlParameter Name="username" 
                ControlID="gvUasers" PropertyName="SelectedValue" 
                Type="String" DefaultValue="." />
        </SelectParameters>
        <DeleteParameters>
            <asp:ControlParameter Name="username" 
                ControlID="gvUasers" PropertyName="SelectedValue" 
                Type="String" />
        </DeleteParameters>
    </asp:ObjectDataSource>
</asp:Content>

