<%@ Page Language="C#" MasterPageFile="~/MasterPage.master" Title=" " Inherits="PathPageBase" %>
<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!string.IsNullOrEmpty(Request.QueryString["ReturnUrl"]))
            hlBack.NavigateUrl = Server.UrlDecode(Request.QueryString["ReturnUrl"]);
        else
            hlBack.Visible = false;
    }
    
    public override SiteMapNode TransformSiteMapPath(object sender, SiteMapResolveEventArgs e)
    {
        string reqUrl = Server.UrlDecode(Request.QueryString["ReqUrl"]);
        if (reqUrl == null)
            return null;

        Uri uri = new Uri("http://" + Request.Url.Authority + reqUrl);
        SiteMapNode sourceNode = e.Provider.FindSiteMapNode(uri.LocalPath);
        sourceNode = sourceNode.Clone(true);
        SiteMapNode tmpNode = sourceNode.ParentNode;
        int deep = 0;
        while (tmpNode != null) {
            tmpNode = tmpNode.ParentNode;
            deep++;
        }

        string[] aQuery = uri.Query.TrimStart(new char[] { '?' }).Split(new char[] { '&' });
        NameValueCollection querys = new NameValueCollection();
        char[] sep = new char[] { '=' };
        foreach (string q in aQuery) {
            if (string.IsNullOrEmpty(q)) 
                continue;
            string[] nv = q.Split(sep);
            querys[nv[0]] = nv[1];
        }

        string connStr = ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString;
        BoardClass board = new BoardClass(int.Parse(querys["board"]), connStr);
        tmpNode = sourceNode;
        if (deep == 2) {
            tmpNode.Title += ": " + board.Subject;
        }
        else {
            ItemClass item = new ItemClass(board, int.Parse(querys["no"]), connStr);
            tmpNode.Title += ": " + item.Title;
            tmpNode = tmpNode.ParentNode;
            tmpNode.Title += ": " + board.Subject;
            tmpNode.Url = "";
            //tmpNode.Url = "?board=" + querys["board"];
        }
        return sourceNode;
    }
</script>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <br />
    <h3> ִ  ϴ.</h3>
    <br />
    <asp:HyperLink ID="hlBack" runat="server" >ư</asp:HyperLink>
</asp:Content>

