<%@ Page Language="C#" MasterPageFile="~/MasterPage.master" Title=" " %>
<script runat="server">
    protected void gvBoardList_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow
            && (e.Row.RowState & DataControlRowState.Edit) == DataControlRowState.Edit)
        {
            BoardClass board = (BoardClass)e.Row.DataItem;
            CheckBoxList cblRoles =
                (CheckBoxList)e.Row.FindControl("cblRoles");
            CheckBoxList cblUsers =
                (CheckBoxList)e.Row.FindControl("cblUsers");
            string[] roles = Roles.GetAllRoles();
            MembershipUserCollection users = Membership.GetAllUsers();

            cblRoles.DataSource = roles;
            cblRoles.DataBind();
            foreach (string role in roles) {
                if (board.IsInRoles(role))
                    cblRoles.Items.FindByText(role).Selected = true;
            }
            
            cblUsers.DataSource = users;
            cblUsers.DataTextField = "UserName";
            cblUsers.DataBind();
            cblUsers.Items.Insert(0, new ListItem(" ", "*"));
            cblUsers.Items.Insert(1, new ListItem(" ", "?"));
            if (board.IsInUsers("*", false, false))
                cblUsers.Items[0].Selected = true;
            if (board.IsInUsers("?", false, false))
                cblUsers.Items[1].Selected = true;
            foreach (MembershipUser user in users) {
                if (board.IsInUsers(user.UserName, false, false))
                    cblUsers.Items.FindByValue(user.UserName).Selected = true;
            }
        }
    }

    protected void gvBoardList_RowUpdating(object sender, GridViewUpdateEventArgs e)
    {
        GridViewRow gvRow = gvBoardList.Rows[e.RowIndex];
        CheckBoxList cblRoles = (CheckBoxList)gvRow.FindControl("cblRoles");
        CheckBoxList cblUsers = (CheckBoxList)gvRow.FindControl("cblUsers");
        string roles = string.Empty;
        string users = string.Empty;

        foreach (ListItem item in cblRoles.Items)
            if (item.Selected)
                roles += item.Value + ";";
        foreach (ListItem item in cblUsers.Items)
            if (item.Selected) {
                if (item.Value.Equals("*")) {
                    users = "*";
                    break;
                }
                else if (item.Value.Equals("?")) {
                    users = "?";
                    break;
                }
                else
                    users += item.Value + ";";
            }

        if (!roles.Equals(string.Empty) && roles[roles.Length - 1] == ';')
            roles = roles.Remove(roles.Length - 1);
        if (!users.Equals(string.Empty) && users[users.Length - 1] == ';')
            users = users.Remove(users.Length - 1);

        e.NewValues["allowRoles"] = roles;
        e.NewValues["allowUsers"] = users;
    }

    protected void btnInsert_Click(object sender, EventArgs e)
    {
        ObjectDataSource1.Insert();
        Response.Redirect(Request.RawUrl);
        //gvBoardList.DataBind();
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        if ((int)e.ReturnValue == -1) {
            lblInsertError.Visible = true;
        }
        else {
            txtSubject.Text = "";
            txtTableName.Text = "";
            lblInsertError.Visible = false;
        }
    }
</script>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <h2> </h2>
    <asp:GridView ID="gvBoardList" runat="server" 
        CellPadding="4" GridLines="None" 
        AutoGenerateColumns="False" 
        DataSourceID="ObjectDataSource1" 
        AutoGenerateEditButton="True" 
        DataKeyNames="no,TableName"
        OnRowDataBound="gvBoardList_RowDataBound" 
        OnRowUpdating="gvBoardList_RowUpdating">
        <Columns>
            <asp:BoundField DataField="No" HeaderText="No" ReadOnly="True" />
            <asp:BoundField DataField="TableName" HeaderText="̺" ReadOnly="True" />
            <asp:BoundField DataField="Subject" HeaderText="" />
            <asp:TemplateField HeaderText="AllowUsers">
                <EditItemTemplate>
                    <asp:CheckBoxList ID="cblUsers" runat="server" />
                </EditItemTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label1" runat="server" 
                        Text='<%# Eval("AllowUsers") %>' />
                </ItemTemplate>
                <ItemStyle VerticalAlign="Top" />
            </asp:TemplateField>
            <asp:TemplateField HeaderText="AllowRoles">
                <EditItemTemplate>
                    <asp:CheckBoxList ID="cblRoles" runat="server" />
                </EditItemTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label2" runat="server" 
                        Text='<%# Eval("AllowRoles") %>' />
                </ItemTemplate>
                <ItemStyle VerticalAlign="Top" />
            </asp:TemplateField>
        </Columns>
        <RowStyle BackColor="#E3EAEB" />
        <EditRowStyle BackColor="#7C6F57" />
        <HeaderStyle BackColor="#1C5E55" Font-Bold="True" ForeColor="White" />
        <AlternatingRowStyle BackColor="White" />
    </asp:GridView>
    <asp:ObjectDataSource ID="ObjectDataSource1" runat="server" 
        SelectMethod="GetBoardList" TypeName="BoardInfo" 
        InsertMethod="InsertBoard" UpdateMethod="UpdateBoard" 
        OnInserted="ObjectDataSource1_Inserted">
        <UpdateParameters>
            <asp:Parameter Name="no" Type="Int32" />
            <asp:Parameter Name="subject" Type="String" />
            <asp:Parameter Name="tableName" Type="String" />
            <asp:Parameter Name="allowRoles" Type="String" />
            <asp:Parameter Name="allowUsers" Type="String" />
        </UpdateParameters>
        <InsertParameters>
            <asp:ControlParameter Name="subject" ControlID="txtSubject" />
            <asp:ControlParameter Name="tableName" ControlID="txtTableName" />
            <asp:Parameter Name="allowRoles" DefaultValue="" />
            <asp:Parameter Name="allowUsers" DefaultValue="*" />
        </InsertParameters>
    </asp:ObjectDataSource>
    <br />
    <asp:Panel ID="Panel1" runat="server" GroupingText=" Խ " Width="350">
        <table>
            <tr>
                <td width="120" align="right" valign="top"><b> :</b></td>
                <td>
                    <asp:TextBox ID="txtSubject" runat="server" />
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator1" 
                        runat="server" ControlToValidate="txtSubject"
                        ErrorMessage="<br> Էϼ" 
                        Display="Dynamic" ValidationGroup="NewBoard" />
                </td>
            </tr>
            <tr>
                <td align="right" valign="top"><b> ̺ :</b></td>
                <td >
                    <asp:TextBox ID="txtTableName" runat="server" />
                    <asp:RequiredFieldValidator ID="RequiredFieldValidator2" 
                        runat="server" ControlToValidate="txtTableName"
                        ErrorMessage="<br>̺ ̸ Էϼ" 
                        Display="Dynamic" ValidationGroup="NewBoard" />
                </td>
            </tr>
            <tr>
                <td></td>
                <td>
                    <asp:Button ID="btnInsert" runat="server" 
                        Text="Խ ߰" OnClick="btnInsert_Click" 
                        ValidationGroup="NewBoard" />
                </td>
            </tr>
        </table>
        <asp:Label ID="lblInsertError" runat="server" 
            Text="Խ ߰ ߽ϴ. ߰Ϸ  ̺ ͺ̽ ̹ ϴ Ȯϼ." 
            ForeColor="Red" Visible="false" />
    </asp:Panel>
</asp:Content>

