using System;
using System.Configuration;
using System.Web.UI;
using System.Web;

public abstract class BoardPageBase : PathPageBase
{
    protected BoardClass _board = null;
    protected override void OnInit(EventArgs e)
    {
        if (string.IsNullOrEmpty(Request.QueryString["board"]))
            throw new InvalidOperationException("board ĶͰ ޵ ʾҽϴ.");
        int boardNo = int.Parse(Request.QueryString["board"]);
        string connStr = ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString;
        _board = new BoardClass(boardNo, connStr);
        if (!_board.IsAuthenticatedUser) {
            string returnPage = "~/AccessDenied.aspx";
            if (Request.UrlReferrer != null)
                returnPage +=  "?ReturnUrl=" 
                    + Server.UrlEncode(Request.UrlReferrer.PathAndQuery)
                    + "&ReqUrl="
                    + Server.UrlEncode(Request.RawUrl);
            else
                returnPage += "?ReqUrl="
                    + Server.UrlEncode(Request.RawUrl);

            Response.Redirect(returnPage);
        }

        base.OnInit(e);
    }
}
