<%@ Page Language="C#" MasterPageFile="~/MasterPage.master" Title="" Inherits="BoardPageBase" %>
<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack) {
            if (!Request.IsAuthenticated)
                hlWrite.Visible = false;
            else
                hlWrite.NavigateUrl = "~/Board/Content.aspx?board=" 
                    + Request.QueryString["board"]
                    + "&mode=insert";

            lblBoardTitle.Text = _board.Subject;
        }
    }

    protected void odsBoard_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["board"] = this._board;
    }
    
    protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow) {
            ItemClass item = (ItemClass)e.Row.DataItem;
            if (!item.IsAuthenticatedUser)
                e.Row.Cells[2].Enabled = false;
        }
    }

    public override SiteMapNode TransformSiteMapPath(object sender, SiteMapResolveEventArgs e)
    {
        SiteMapNode currentNode = SiteMap.CurrentNode.Clone(true);
        currentNode.Title += ": " + _board.Subject;
        return currentNode;
    }
</script>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <asp:Label ID="lblBoardTitle" runat="server" Font-Bold="True" Font-Size="Large" />
    <br /><br />
    <asp:GridView ID="GridView1" runat="server" 
        AutoGenerateColumns="False" DataSourceID="odsBoard" 
        OnRowDataBound="GridView1_RowDataBound" 
        CellPadding="4" ForeColor="#333333" GridLines="None">
        <Columns>
            <asp:BoundField DataField="No" HeaderText="No" SortExpression="No"/>
            <asp:BoundField DataField="WriterName" HeaderText="ۼ" 
                SortExpression="WriterName" />
            <asp:HyperLinkField DataNavigateUrlFields="BoardNo,No" 
                DataNavigateUrlFormatString="Content.aspx?board={0}&no={1}"
                DataTextField="Title" HeaderText="" 
                SortExpression="Title">
                <ControlStyle Width="100px" />
            </asp:HyperLinkField>
            <asp:BoundField DataField="ReadCount" HeaderText="ȸ" 
                SortExpression="ReadCount" />
            <asp:BoundField DataField="RegDate" HeaderText="¥" 
                SortExpression="RegDate" DataFormatString="{0:yyyy-MM-dd}" />
            <asp:BoundField DataField="AllowRoles" HeaderText="AllowRoles" 
                SortExpression="AllowRoles" />
            <asp:BoundField DataField="AllowUsers" HeaderText="AllowUsers" 
                SortExpression="AllowUsers" />
        </Columns>
        <RowStyle BackColor="#EFF3FB" />
        <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
        <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
        <AlternatingRowStyle BackColor="White" />
    </asp:GridView>
    <asp:ObjectDataSource ID="odsBoard" runat="server" 
        TypeName="BoardCompont" SelectMethod="GetItems" 
        SortParameterName="sortExpression" 
        OnSelecting="odsBoard_Selecting">
        <SelectParameters>
            <asp:Parameter Name="board" Type="Object" />
        </SelectParameters>
    </asp:ObjectDataSource>
    <br />
    <asp:HyperLink ID="hlWrite" runat="server" >۾</asp:HyperLink>
</asp:Content>
