<%@ Control Language="C#" ClassName="SitemapAPI3" %>
<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {
        SiteMapNode currentNode = SiteMap.CurrentNode;
        SiteMapNode tmpNode = currentNode;
        HyperLink link;
        DropDownList ddl;
        Control ctrl;
        bool isFirst = true;
        while (tmpNode != null) {
            if (tmpNode != currentNode || tmpNode.ParentNode == null) {
                link = new HyperLink();
                link.Text = tmpNode.Title;
                link.NavigateUrl = tmpNode.Url;
                link.ToolTip = tmpNode.Description;
                ctrl = link;
            }
            else {
                ddl = new DropDownList();
                /*
                ddl.DataSource = tmpNode.ParentNode.ChildNodes;
                ddl.DataTextField = "Title";
                ddl.DataValueField = "Url";
                ddl.DataBind();
                 * */
                ListItem item;
                foreach (SiteMapNode n in tmpNode.ParentNode.ChildNodes) {
                    item = new ListItem(n.Title, n.Url);
                    item.Enabled = !string.IsNullOrEmpty(n.Url);
                    ddl.Items.Add(item);
                }
                ddl.SelectedValue = tmpNode.Url;
                ddl.Attributes["onchange"] = "window.location.href=this.options[this.selectedIndex].value";
                ctrl = ddl;
            }

            if (isFirst) {
                isFirst = false;
                phSitemapPath.Controls.Add(new LiteralControl("<b>Ʈ API : </b>"));
            }
            else {
                phSitemapPath.Controls.AddAt(1, new LiteralControl(" > "));
            }
            phSitemapPath.Controls.AddAt(1, ctrl);
            tmpNode = tmpNode.ParentNode;
        }
    }
</script>

<asp:PlaceHolder ID="phSitemapPath" runat="server" />
