<%@ Control Language="C#" ClassName="DisplayModeMenuCS" %>
<script runat="server">
    WebPartManager _manager;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Request.IsAuthenticated) {
            this.Visible = false;
            return;
        }

        _manager = WebPartManager.GetCurrentWebPartManager(Page);
        if (!IsPostBack) {
            foreach (WebPartDisplayMode mode in _manager.SupportedDisplayModes) {
                String modeName = mode.Name;
                if (mode.IsEnabled(_manager)) {
                    ListItem item = new ListItem(modeName, modeName);
                    DisplayModeDropdown.Items.Add(item);
                }
            }

            if (_manager.Personalization.CanEnterSharedScope) {
                Panel2.Visible = true;
                if (_manager.Personalization.Scope == PersonalizationScope.User)
                    RadioButton1.Checked = true;
                else
                    RadioButton2.Checked = true;
            }
        }
    }
    
    void DisplayModeDropdown_SelectedIndexChanged(object sender, EventArgs e)
    {
        String selectedMode = DisplayModeDropdown.SelectedValue;

        WebPartDisplayMode mode = _manager.SupportedDisplayModes[selectedMode];
        if (mode != null)
            _manager.DisplayMode = mode;
    }

    protected void LinkButton1_Click(object sender, EventArgs e)
    {
        _manager.Personalization.ResetPersonalizationState();
    }

    protected void RadioButton1_CheckedChanged(object sender, EventArgs e)
    {
        if (_manager.Personalization.Scope == PersonalizationScope.Shared)
            _manager.Personalization.ToggleScope();
    }

    protected void RadioButton2_CheckedChanged(object sender, EventArgs e)
    {
        if (_manager.Personalization.CanEnterSharedScope &&
            _manager.Personalization.Scope == PersonalizationScope.User)
            _manager.Personalization.ToggleScope();
    }
</script>
<div>
  <asp:Panel ID="Panel1" runat="server" 
    Borderwidth="1" Width="230" BackColor="lightgray" >
    <asp:Label ID="Label1" runat="server" 
      Text="&nbsp; " Font-Bold="true"
      Font-Size="8" Width="120" />
    <asp:DropDownList ID="DisplayModeDropdown" 
      runat="server" AutoPostBack="true" Width="120"
      OnSelectedIndexChanged="DisplayModeDropdown_SelectedIndexChanged" />
    <asp:LinkButton ID="LinkButton1" runat="server"
      Text=" ʱȭ" Font-Size="8" 
      ToolTip="  Ʈ  ʱȭմϴ."
      OnClick="LinkButton1_Click" />
    <asp:Panel ID="Panel2" runat="server" 
      GroupingText=" " Font-Bold="true"
      Font-Size="8" Visible="false" >
      <asp:RadioButton ID="RadioButton1" 
        runat="server" Text="User" 
        AutoPostBack="true" GroupName="Scope" 
        OnCheckedChanged="RadioButton1_CheckedChanged" />
      <asp:RadioButton ID="RadioButton2" 
        runat="server" Text="Shared" 
        AutoPostBack="true" GroupName="Scope" 
        OnCheckedChanged="RadioButton2_CheckedChanged" />
    </asp:Panel>
  </asp:Panel>
</div>

