using System;
using System.Drawing.Design;
using System.ComponentModel;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;

namespace MyWebParts {
    public class ImageLink : WebPart {
        private string _imageUrl;
        private string _navigateUrl;
        private ImageLinkTarget _target = ImageLinkTarget._self;
        private HyperLink _link;

        public enum ImageLinkTarget { _blank, _self, _parent }

        [WebBrowsable,
        WebDisplayName("")]
        public override string Title {
            get { return base.Title; }
            set { base.Title = value; }
        }
        [Personalizable,
        WebBrowsable,
        WebDisplayName("̹ "),
        EditorAttribute("System.Web.UI.Design.ImageUrlEditor, System.Design", ((Type)typeof(UITypeEditor)))]
        public string ImageUrl {
            get { return _imageUrl; }
            set {
                _imageUrl = value;
                if (_link != null)
                    _link.ImageUrl = _imageUrl;
            }
        }
        [Personalizable,
        WebBrowsable,
        WebDisplayName(" ּ"),
        EditorAttribute("System.Web.UI.Design.UrlEditor, System.Design", ((Type)typeof(UITypeEditor)))]
        public string NavigateUrl {
            get { return _navigateUrl; }
            set {
                _navigateUrl = value;
                if (_link != null)
                    _link.NavigateUrl = _navigateUrl;
            }
        }
        [Personalizable,
        WebBrowsable,
        WebDisplayName(" â"),
        DefaultValue(ImageLinkTarget._self)]
        public ImageLinkTarget Target {
            get { return _target; }
            set {
                _target = value;
                if (_link != null)
                    _link.Target = _target.ToString();
            }
        }

        public ImageLink() { }

        protected override void CreateChildControls()
        {
            _link = new HyperLink();
            _link.NavigateUrl = _navigateUrl;
            _link.ImageUrl = _imageUrl;
            _link.Target = _target.ToString();
            Controls.Add(_link);
            base.CreateChildControls();
        }
    }
}