using System;
using System.Drawing.Design;
using System.ComponentModel;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;

namespace MyWebParts {
    public class ImageLink2 : WebPart {
        private string _imageUrl;
        private string _navigateUrl;
        private string _target;
        private HyperLink _link;
        private bool _imageInputType = false;

        [WebBrowsable,
        WebDisplayName("")]
        public override string Title {
            get { return base.Title; }
            set { base.Title = value; }
        }
        [Personalizable,
        WebBrowsable,
        WebDisplayName("̹ "),
        EditorAttribute("System.Web.UI.Design.ImageUrlEditor, System.Design", ((Type)typeof(UITypeEditor)))]
        public string ImageUrl {
            get { return _imageUrl; }
            set {
                _imageUrl = value;
                if (_link != null)
                    _link.ImageUrl = _imageUrl;
            }
        }
        [Personalizable,
        WebBrowsable,
        WebDisplayName(" ּ"),
        EditorAttribute("System.Web.UI.Design.UrlEditor, System.Design", ((Type)typeof(UITypeEditor)))]
        public string NavigateUrl {
            get { return _navigateUrl; }
            set {
                _navigateUrl = value;
                if (_link != null)
                    _link.NavigateUrl = _navigateUrl;
            }
        }
        [Personalizable,
        WebBrowsable,
        WebDisplayName(" â")]
        public string Target {
            get { return _target; }
            set {
                _target = value;
                if (_link != null)
                    _link.Target = _target;
            }
        }

        private string _ImageRoot;
        private string[] _targets;
        public string ImageRoot {
            get { return _ImageRoot;  }
            set { 
                _ImageRoot = value;
                if (string.IsNullOrEmpty(_imageUrl))
                    return;
                _imageUrl = _imageUrl.TrimEnd(new char[] {'/', '\\'}) + "/";
            }
        }
        [EditorAttribute("System.Web.UI.Design.WebControls.DataFieldEditor, System.Design", ((Type)typeof(UITypeEditor))),
        TypeConverterAttribute(((Type)typeof(StringArrayConverter)))]
        public string[] Targets {
            get { 
                if (_targets == null)
                    return new string[0];
                else 
                    return _targets;
            }
            set { _targets = value; }
        }
        [Personalizable]
        public bool ImageInputType {
            get { return _imageInputType; }
            set { _imageInputType = value; }
        }

        public ImageLink2() { }

        protected override void CreateChildControls()
        {
            _link = new HyperLink();
            _link.NavigateUrl = _navigateUrl;
            _link.ImageUrl = _imageUrl;
            _link.Target = _target;
            Controls.Add(_link);
            base.CreateChildControls();
        }

        public override EditorPartCollection CreateEditorParts()
        {
            List<EditorPart> customEditorPartCollection = new List<EditorPart>();
            customEditorPartCollection.Add(new ImageLinkEditorPart());
            EditorPartCollection editorPartCollection = new EditorPartCollection(customEditorPartCollection);
            return editorPartCollection;
        }
    }
}