using System;
using System.IO;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace MyWebParts 
{
    public interface ITextDisplay {
        string Content { get; set; }
        FontSize FontSize { get; set; }
    }

    public class TextDisplayEditorPart : EditorPart
    {
        DropDownList _ddlFontSize = null;
        TextBox _txtTitle = null;
        TextBox _txtContent = null;

        public TextDisplayEditorPart()
        {
            this.ID = "TextDisplayEditorPart";
            this.Title = "TextDisplay Ʈ ";
        }

        protected override void CreateChildControls()
        {
            Controls.Clear();

            _txtTitle = new TextBox();
            _ddlFontSize = new DropDownList();
            _txtContent = new TextBox();
            _txtContent.TextMode = TextBoxMode.MultiLine;
            _txtContent.Rows = 4;

            this.Controls.Add(new LiteralControl(" : "));
            this.Controls.Add(new LiteralControl("<br />"));
            this.Controls.Add(_txtTitle);
            this.Controls.Add(new LiteralControl("<br />"));
            this.Controls.Add(new LiteralControl("ũ : "));
            this.Controls.Add(new LiteralControl("<br />"));
            this.Controls.Add(_ddlFontSize);
            this.Controls.Add(new LiteralControl("<br />"));
            this.Controls.Add(new LiteralControl(" : "));
            this.Controls.Add(new LiteralControl("<br />"));
            this.Controls.Add(_txtContent);
        }

        public override void SyncChanges()
        {
            EnsureChildControls();

            ITextDisplay textDisplay = WebPartToEdit.WebBrowsableObject as ITextDisplay;
            if (textDisplay != null) {
                _ddlFontSize.Items.Clear();
                _ddlFontSize.Items.Add("NotSet");
                _ddlFontSize.Items.Add("AsUnit");
                _ddlFontSize.Items.Add("Smaller");
                _ddlFontSize.Items.Add("Larger");
                _ddlFontSize.Items.Add("XXSmall");
                _ddlFontSize.Items.Add("XSmall");
                _ddlFontSize.Items.Add("Small");
                _ddlFontSize.Items.Add("Medium");
                _ddlFontSize.Items.Add("Large");
                _ddlFontSize.Items.Add("XLarge");
                _ddlFontSize.Items.Add("XXLarge");

                try {
                    _ddlFontSize.SelectedValue = textDisplay.FontSize.ToString();
                }
                catch { }
                _txtContent.Text = textDisplay.Content;
                _txtTitle.Text = WebPartToEdit.Title;
            }
        }

        public override bool ApplyChanges()
        {
            EnsureChildControls();

            ITextDisplay textDisplay = WebPartToEdit.WebBrowsableObject as ITextDisplay;
            if (textDisplay != null) {
                WebPartToEdit.Title = _txtTitle.Text;
                textDisplay.Content = _txtContent.Text;
                textDisplay.FontSize = FontUnit.Parse(_ddlFontSize.SelectedValue).Type;
            }
            return true;
        }
    }
}



