<%@ Page Language="C#" validateRequest="false" %>
<%@ Register Src="TextDisplay.ascx" TagName="TextDisplay" TagPrefix="uc1" %>
<%@ Register TagPrefix="MyWebParts" Namespace="MyWebParts" %>
<%@ Register Src="../DisplayModeMenu.ascx" TagName="DisplayModeMenu" TagPrefix="uc2" %>
<script runat="server">
    WebPartManager _manager;
    bool webpartChanged = false;
    protected void Page_Load(object sender, EventArgs e)
    {
        _manager = WebPartManager1;
    }

    private Control[] GetDeclaredControls()
    {
        ArrayList controls = new ArrayList();
        foreach (Control cont in pnlControls.Controls) {
            if (!typeof(LiteralControl).Equals(cont.GetType())) {
                controls.Add(cont);
            }
        }
        Control[] sourceControls = new Control[controls.Count];
        controls.CopyTo(sourceControls, 0);

        return sourceControls;
    }

    private ArrayList GetWebParts(bool isOpened) {
        ArrayList parts = new ArrayList();
        foreach (WebPart part in _manager.WebParts) {
            if (part.IsClosed ^ isOpened)
                parts.Add(part);
        }
        return parts;
    }
    
    protected void WebPartManager1_WebPartClosed(object sender, WebPartEventArgs e)
    {
        webpartChanged = true;
    }

    protected void WebPartManager1_WebPartAdded(object sender, WebPartEventArgs e)
    {
        webpartChanged = true;
    }
    
    protected void WebPartManager1_WebPartDeleted(object sender, WebPartEventArgs e)
    {
        webpartChanged = true;
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (!IsPostBack || webpartChanged) {
            if (!Request.IsAuthenticated) {
                tdCatalogs.Visible = false;
                return;
            }

            if (!IsPostBack) {
                ddlZones1.Items.Clear();
                ddlZones2.Items.Clear();
                foreach (WebPartZoneBase zone in _manager.Zones) {
                    ddlZones1.Items.Add(zone.ID);
                    ddlZones2.Items.Add(zone.ID);
                }

                cblDeclartiveCatalogPart.DataSource = GetDeclaredControls();
                cblDeclartiveCatalogPart.DataTextField = "ID";
                cblDeclartiveCatalogPart.DataBind();
            }

            cblDeleteOne.DataSource = GetWebParts(true);
            cblDeleteOne.DataTextField = "DisplayTitle";
            cblDeleteOne.DataBind();

            cblPageCatalogPart.DataSource = GetWebParts(false);
            cblPageCatalogPart.DataTextField = "DisplayTitle";
            cblPageCatalogPart.DataBind();
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        Control[] controls = GetDeclaredControls();
        for (int i = 0; i < cblDeclartiveCatalogPart.Items.Count; i++) {
            ListItem item = cblDeclartiveCatalogPart.Items[i];
            if (item.Selected) {
                WebPart part;
                if (controls[i] is WebPart)
                    part = (WebPart)controls[i];
                else {
                    part = _manager.CreateWebPart(controls[i]);
                }
                WebPartZoneBase zone = _manager.Zones[ddlZones1.SelectedValue];
                _manager.AddWebPart(part, zone, 0);
                item.Selected = false;
            }
        }
    }
    
    protected void Button2_Click(object sender, EventArgs e)
    {
        ArrayList parts = GetWebParts(true);
        for (int i = 0; i < cblDeleteOne.Items.Count; i++) {
            ListItem item = cblDeleteOne.Items[i];
            if (item.Selected) {
                WebPart part = (WebPart)parts[i];
                if (part.IsStatic)
                    _manager.CloseWebPart((WebPart)parts[i]);
                else
                    _manager.DeleteWebPart((WebPart)parts[i]);
            }
        }
    }
    
    protected void Button3_Click(object sender, EventArgs e)
    {
        ArrayList parts = GetWebParts(false);
        for (int i = 0; i < cblPageCatalogPart.Items.Count; i++) {
            ListItem item = cblPageCatalogPart.Items[i];
            if (item.Selected) {
                WebPartZoneBase zone = _manager.Zones[ddlZones2.SelectedValue];
                _manager.AddWebPart((WebPart)parts[i], zone, 0);
            }
        }
    }
</script>
<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title> ε</title>
</head>
<body>
    <form id="form1" runat="server">
        <asp:LoginName ID="LoginName1" runat="server" />
        <asp:LoginStatus ID="LoginStatus1" runat="server" />
        <asp:WebPartManager ID="WebPartManager1" runat="server" 
            OnWebPartClosed="WebPartManager1_WebPartClosed" 
            OnWebPartAdded="WebPartManager1_WebPartAdded" 
            OnWebPartDeleted="WebPartManager1_WebPartDeleted" />
        <uc2:DisplayModeMenu ID="DisplayModeMenu1" runat="server" />
        <table border="0">
            <tr>
                <td valign="top" style="width:100px">
    <asp:WebPartZone ID="LeftZone" runat="server">
        <ZoneTemplate>
            <MyWebParts:ImageLink2 ID="ImageLink21" runat="server" 
               NavigateUrl="http://asp.net" 
               ImageUrl="~/Images/ASP_NET.gif/" 
               Title="ASP.NET" Targets="_blank,_top,_self" 
               ImageRoot="~/Images/" ImageInputType="False" />
        </ZoneTemplate>
    </asp:WebPartZone>
    <asp:EditorZone ID="EditorZone1" runat="server">
    </asp:EditorZone>
                </td>
                <td valign="top" style="width:100px">
    <asp:WebPartZone ID="CenterZone" runat="server">
        <ZoneTemplate>
            <uc1:TextDisplay ID="TextDisplay1" runat="server" Title="TextDisplay Ʈ" />
        </ZoneTemplate>
    </asp:WebPartZone>
                </td>
                <td valign="top" runat="server" ID="tdCatalogs">
    <asp:Panel ID="Panel1" runat="server" GroupingText="DeclartiveCatalogPart " >
        <asp:CheckBoxList ID="cblDeclartiveCatalogPart" runat="server" >
        </asp:CheckBoxList>
        <asp:DropDownList ID="ddlZones1" runat="server" />
        <asp:Button ID="Button1" runat="server" Text="߰" OnClick="Button1_Click" />
        <asp:Panel ID="pnlControls" runat="server" Visible="false">
            <MyWebParts:ImageLink2 ID="ImageLink2" runat="server" 
               NavigateUrl="http://asp.net" 
               ImageUrl="~/Images/ASP_NET.gif/" 
               Title="ASP.NET" Targets="_blank,_top,_self" 
               ImageRoot="~/Images/" ImageInputType="False" />
            <uc1:TextDisplay ID="TextDisplay" runat="server" Title="TextDisplay Ʈ" />
            <asp:Calendar ID="Calendar" runat="server" Title="Calendar Ʈ" />
        </asp:Panel>
    </asp:Panel>
    <asp:Panel ID="Panel2" runat="server" GroupingText="PageCatalogPart " >
        <asp:CheckBoxList ID="cblPageCatalogPart" runat="server" />
        <asp:DropDownList ID="ddlZones2" runat="server" />
        <asp:Button ID="Button3" runat="server" Text="" OnClick="Button3_Click" />
    </asp:Panel>
    <asp:Panel ID="Panel3" runat="server" GroupingText=" Ǵ ݱ" >
        <asp:CheckBoxList ID="cblDeleteOne" runat="server" />
        <asp:Button ID="Button2" runat="server" Text="" OnClick="Button2_Click" />
    </asp:Panel>
                </td>
            </tr>
        </table>
    </form>
</body>
</html>