<%@ Page Language="C#" Trace="true" MaintainScrollPositionOnPostback="true"  %>
<%@ Register Src="WebUserControl.ascx" TagName="WebUserControl" TagPrefix="uc1" %>
<%@ Import Namespace="System.IO" %>
<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
            CreateTreeNodes(this, tvPageTree.Nodes[0]);
    }

    void CreateTreeNodes(Control parentControl, TreeNode parentNode) {
        if (parentControl.HasControls()) {
            foreach (Control c in parentControl.Controls) {
                if (c is TreeView)
                    continue;
                
                TreeNode node;
                string text = "<b>" + c.UniqueID + "</b>(" + c.ToString() + ")";

                if (!(c is HtmlForm))
                {
                    StringWriter stringWriter = new StringWriter();
                    Html32TextWriter htmlWriter = new Html32TextWriter(stringWriter);
                    c.RenderControl(htmlWriter);
                    node = new TreeNode(text, stringWriter.ToString());
                }
                else
                    node = new TreeNode(text, "***** Form ± *****");

                parentNode.ChildNodes.Add(node);
                if (c.HasControls())
                    CreateTreeNodes(c, node);
            }
        }
    }

    protected void tvPageTree_SelectedNodeChanged(object sender, EventArgs e)
    {
        this.Controls.Add(new LiteralControl("<hr>"));
        this.Controls.Add(new LiteralControl(Server.HtmlEncode(tvPageTree.SelectedNode.Value)));
        this.Controls.Add(new LiteralControl("<br><br>"));
    }

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:Label ID="Label1" runat="server" Text=" Label Ʈ"></asp:Label><br />
        <br />
        <uc1:WebUserControl ID="WebUserControl1" runat="server" />
        &nbsp;&nbsp;<br />
        <asp:TreeView ID="tvPageTree" runat="server" ImageSet="Inbox" 
        OnSelectedNodeChanged="tvPageTree_SelectedNodeChanged">
            <ParentNodeStyle Font-Bold="False" />
            <SelectedNodeStyle Font-Underline="True" HorizontalPadding="0px"
                VerticalPadding="0px" />
            <Nodes>
                <asp:TreeNode Text="Page Ʈ" Value="Page Ʈ"></asp:TreeNode>
            </Nodes>
            <NodeStyle Font-Names="Verdana" Font-Size="8pt" ForeColor="Black" HorizontalPadding="5px"
                NodeSpacing="0px" VerticalPadding="0px" />
            <HoverNodeStyle Font-Underline="True" />
        </asp:TreeView>
    </div>
    </form>
</body>
</html>
