using System;
using System.Configuration;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

public class PieceBoardListEditPart : EditorPart
{
    DropDownList _ddlBoard = null;
    DropDownList _ddlTopCount = null;

    public PieceBoardListEditPart(string id) {
        this.ID = id;
    }

    protected override void CreateChildControls()
    {
        Controls.Clear();

        LiteralControl literal;
        literal = new LiteralControl("<h3> Խ </h3>");
        this.Controls.Add(literal);

        literal = new LiteralControl("Խ :");
        this.Controls.Add(literal);

        _ddlBoard = new DropDownList();
        _ddlBoard.DataTextField = "subject";
        _ddlBoard.DataValueField = "no";
        BoardInfo bi = new BoardInfo();
        _ddlBoard.DataSource = bi.GetBoardList();
        _ddlBoard.DataBind();
        /*
        string connStr = ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString;
        foreach (ListItem item in _ddlBoard.Items) {
            BoardClass board = new BoardClass(int.Parse(item.Value), connStr);
            item.Enabled = board.IsAuthenticatedUser;
        }
         * */
        this.Controls.Add(_ddlBoard);

        literal = new LiteralControl("<br> :");
        this.Controls.Add(literal);
        _ddlTopCount = new DropDownList();
        for (int i = 1; i <= 10; i++) {
            _ddlTopCount.Items.Add(i.ToString());
        }
        this.Controls.Add(_ddlTopCount);
    }

    public override void SyncChanges()
    {
        EnsureChildControls();

        PieceBoardListPart pieceBoardListPart = WebPartToEdit as PieceBoardListPart;
        if (pieceBoardListPart != null && pieceBoardListPart.BoardNo != -1) {
            _ddlBoard.SelectedValue = pieceBoardListPart.BoardNo.ToString();
            _ddlTopCount.SelectedValue = pieceBoardListPart.TopCount.ToString();
        }
    }

    public override bool ApplyChanges()
    {
        EnsureChildControls();
        PieceBoardListPart pieceBoardListPart = WebPartToEdit as PieceBoardListPart;
        if (pieceBoardListPart != null) {
            int boardNo = int.Parse(_ddlBoard.SelectedValue);
            string connStr = ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString;
            BoardClass board = new BoardClass(boardNo, connStr);
            if (board.IsAuthenticatedUser) {
                pieceBoardListPart.BoardNo = boardNo;
                pieceBoardListPart.TopCount = int.Parse(_ddlTopCount.SelectedValue);
            }
            else {
                this.Zone.ErrorText = "ٱ  ԽԴϴ";
                return false;
            }
        }
        return true;
    }
}
