<%@ Page Language="C#" MasterPageFile="~/MasterPage.master" Title="" Inherits="BoardPageBase" %>
<%@ Import Namespace="System.Collections.Generic" %>
<script runat="server">
    string _mode;
    int _no;
    protected void Page_Load(object sender, EventArgs e)
    {
        _mode = Request.QueryString["mode"];
        if (Request.QueryString["no"] != null)
            _no = int.Parse(Request.QueryString["no"]);
        else
            _no = -1;
        if (!IsPostBack) {
            if (string.IsNullOrEmpty(_mode)) {
                fvWrite.DefaultMode = FormViewMode.ReadOnly;
                ViewState["ReturnUrl"] = this.TemplateSourceDirectory 
                    + "/List.aspx?board=" + Request.QueryString["board"];
            }
            else {
                fvWrite.DefaultMode = FormViewMode.Insert;
                ViewState["ReturnUrl"] = Request.UrlReferrer.PathAndQuery;
            }

            lblBoardTitle.Text = _board.Subject;
        }
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (!IsPostBack) {
            BoardCompont bc = new BoardCompont();
            bc.IncreaseReadCount(_board, _no);
        }
    }

    ItemClass _item = null;
    protected void fvWrite_DataBound(object sender, EventArgs e)
    {
        if (fvWrite.CurrentMode != FormViewMode.ReadOnly) {
            CheckBoxList cblRoles = (CheckBoxList)fvWrite.FindControl("cblRoles");
            CheckBoxList cblUsers = (CheckBoxList)fvWrite.FindControl("cblUsers");
            if (cblRoles != null && cblUsers != null) {
                if (_item == null && 
                    fvWrite.CurrentMode == FormViewMode.Edit)
                    _item = new ItemClass(_board, _no,
                        ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString);
                
                string[] roles = Roles.GetAllRoles();
                List<string> users = _board.GetAvailableUsers();

                cblRoles.DataSource = roles;
                cblRoles.DataBind();
                if (_item != null)
                    foreach (string role in roles) {
                        if (_item.IsInRoles(role))
                            cblRoles.Items.FindByText(role).Selected = true;
                    }
                cblUsers.DataSource = users;
                cblUsers.DataBind();
                cblUsers.Items.Insert(0, new ListItem(" ", "*"));
                cblUsers.Items.Insert(1, new ListItem(" ", "?"));

                if (_item != null) {
                    if (_item.IsInUsers("*", false, false))
                        cblUsers.Items[0].Selected = true;
                    if (_item.IsInUsers("?", false, false))
                        cblUsers.Items[1].Selected = true;
                    foreach (string user in users) {
                        if (_item.IsInUsers(user, false, false))
                            cblUsers.Items.FindByValue(user).Selected = true;
                    }
                }
                else {
                    cblUsers.Items[0].Selected = true;
                }
            }

            HyperLink hlToList = (HyperLink)fvWrite.FindControl("hlToList");
            hlToList.NavigateUrl = (string)ViewState["ReturnUrl"];
        }
        else {
            BulletedList bulRoles = (BulletedList)fvWrite.FindControl("bulRoles");
            BulletedList bulUsers = (BulletedList)fvWrite.FindControl("bulUsers");
            if (_item == null)
                _item = new ItemClass(_board, _no,
                    ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString);

            if (bulRoles != null && bulUsers != null) {
                //bulRoles.Items.Clear();
                //bulUsers.Items.Clear();
                foreach (string role in _item.AllowRoles.Split(new char[] { ';' })) {
                    if (!string.IsNullOrEmpty(role))
                        bulRoles.Items.Add(role);
                }
                foreach (string user in _item.AllowUsers.Split(new char[] { ';' })) {
                    if (user.Equals("*"))
                        bulUsers.Items.Add(" ");
                    else if (user.Equals("?"))
                        bulUsers.Items.Add(" ");
                    else if (!string.IsNullOrEmpty(user))
                        bulUsers.Items.Add(user);
                }
            }
            HyperLink hlToList = (HyperLink)fvWrite.FindControl("hlToList");
            hlToList.NavigateUrl = (string)ViewState["ReturnUrl"];
            if (!_item.IsModifier) {
                LinkButton lbtnEdit = (LinkButton)fvWrite.FindControl("lbtnEdit");
                LinkButton lbtnDelete = (LinkButton)fvWrite.FindControl("lbtnDelete");
                lbtnEdit.Visible = false;
                lbtnDelete.Visible = false;
            }
        }
    }

    protected void fvWrite_ItemInserting(object sender, FormViewInsertEventArgs e)
    {
        e.Values["board"] = _board;
        e.Values["writerName"] = User.Identity.Name;

        CheckBoxList cblRoles = (CheckBoxList)fvWrite.FindControl("cblRoles");
        CheckBoxList cblUsers = (CheckBoxList)fvWrite.FindControl("cblUsers");
        string roles = string.Empty;
        string users = string.Empty;
        
        foreach (ListItem item in cblRoles.Items)
            if (item.Selected)
                roles += item.Value + ";";
        foreach (ListItem item in cblUsers.Items)
            if (item.Selected) {
                if (item.Value.Equals("*")) {
                        users = "*";
                        break;
                }
                else if (item.Value.Equals("?")) {
                    users = "?";
                    break;
                }
                else
                    users += item.Value + ";";
            }

        if (!roles.Equals(string.Empty) && roles[roles.Length - 1] == ';')
            roles = roles.Remove(roles.Length - 1);
        if (!users.Equals(string.Empty) && users[users.Length - 1] == ';')
            users = users.Remove(users.Length - 1);
        
        e.Values["allowRoles"] = roles;
        e.Values["allowUsers"] = users;
    }

    protected void fvWrite_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        if (e.Exception == null)
            Response.Redirect((string)ViewState["ReturnUrl"]);
    }

    protected void fvWrite_ItemUpdating(object sender, FormViewUpdateEventArgs e)
    {
        e.NewValues["board"] = _board;

        CheckBoxList cblRoles = (CheckBoxList)fvWrite.FindControl("cblRoles");
        CheckBoxList cblUsers = (CheckBoxList)fvWrite.FindControl("cblUsers");
        string roles = string.Empty;
        string users = string.Empty;

        foreach (ListItem item in cblRoles.Items)
            if (item.Selected)
                roles += item.Value + ";";
        foreach (ListItem item in cblUsers.Items)
            if (item.Selected) {
                if (item.Value.Equals("*")) {
                    users = "*";
                    break;
                }
                else if (item.Value.Equals("?")) {
                    users = "?";
                    break;
                }
                else
                    users += item.Value + ";";
            }

        if (!roles.Equals(string.Empty) && roles[roles.Length - 1] == ';')
            roles = roles.Remove(roles.Length - 1);
        if (!users.Equals(string.Empty) && users[users.Length - 1] == ';')
            users = users.Remove(users.Length - 1);
        
        e.NewValues["allowRoles"] = roles;
        e.NewValues["allowUsers"] = users;
    }

    protected void fvWrite_ItemDeleted(object sender, FormViewDeletedEventArgs e)
    {
        Response.Redirect((string)ViewState["ReturnUrl"]);
    }
    
    protected void ObjectDataSource1_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["board"] = _board;
    }
    
    protected void ObjectDataSource1_Deleting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["board"] = _board;
    }

    public override SiteMapNode TransformSiteMapPath(object sender, SiteMapResolveEventArgs e)
    {
        SiteMapNode currentNode = SiteMap.CurrentNode.Clone(true);
        SiteMapNode tmpNode = currentNode;
        if (_mode != "insert") {
            if (_item == null)
                _item = new ItemClass(_board, _no,
                    ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString);

            if (!IsPostBack)
                tmpNode.Title = ": " + _item.Title;
            else
                tmpNode.Title = ": " + _item.Title;
        }
        else
            tmpNode.Title = " ۾";

        return currentNode;
    }
</script>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
    <asp:Label ID="lblBoardTitle" runat="server" Font-Bold="True" Font-Size="Large" />
    <br /><br />
    <asp:FormView ID="fvWrite" runat="server" 
        DataSourceID="ObjectDataSource1" DefaultMode="Insert" 
        OnItemInserted="fvWrite_ItemInserted" 
        OnDataBound="fvWrite_DataBound" 
        OnItemInserting="fvWrite_ItemInserting" 
        OnItemUpdating="fvWrite_ItemUpdating" 
        OnItemDeleted="fvWrite_ItemDeleted" 
        Caption="//߰" BackColor="#E0E0E0" 
        BorderColor="Gray" BorderWidth="1px" Width="400px">
        <ItemTemplate>
            <table border="0" cellpadding="0" width="100%">
                <tr>
                    <td width="100" style="background-color:#EEEEE0"><b>̵</b></td>
                    <td>
    <asp:Label ID="lblUserName" runat="server" Text='<%# Eval("writerName") %>' />
                    </td>
                </tr>
                <tr>
                    <td style="background-color:#EEEEE0"><b></b></td>
                    <td>
    <asp:Label ID="lblTitle" runat="server" Text='<%# Eval("title") %>' />
                    </td>
                </tr>
                <tr>
                    <td valign="top" style="background-color:#EEEEE0"><b></b></td>
                    <td valign="top" height="100">
    <asp:TextBox ID="txtContent" runat="server" Text='<%# Eval("content") %>' 
        Enabled="false" Rows="8" TextMode="MultiLine" Columns="25" />
                    </td>
                </tr>
                <tr>
                    <td valign="top" style="background-color:#EEEEE0"><b>Ѽ</b></td>
                    <td>
                    <table border="0" cellpadding="0">
                        <tr style="color:Blue">
                            <td align="center"></td>
                            <td align="center"></td>
                        </tr>
                        <tr>
                            <td valign="top">
    <asp:BulletedList ID="bulRoles" runat="server" />
                            </td>
                            <td valign="top">
    <asp:BulletedList ID="bulUsers" runat="server" />
                            </td>
                        </tr>
                    </table>
                    </td>
                </tr>
                <tr>
                    <td style="background-color:#EEEEE0"></td>
                    <td>
    <asp:LinkButton ID="lbtnEdit" runat="server" CommandName="Edit" Text="" />
    <asp:LinkButton ID="lbtnDelete" runat="server" CommandName="Delete" 
        Text="" OnClientClick="return confirm(' Ͻðڽϱ?');" />
    <asp:HyperLink ID="hlToList" runat="server" Text="" />
                    </td>
                </tr>
            </table>
        </ItemTemplate>
        <EditItemTemplate>
            <table border="0" cellpadding="0" width="100%">
                <tr>
                    <td width="100"><b>̵</b></td>
                    <td>
    <asp:Label ID="lblUserName" runat="server" Text="<%# User.Identity.Name %>" />
                    </td>
                </tr>
                <tr>
                    <td></td>
                    <td>
    <asp:TextBox ID="txtTitle" runat="server" Text='<%# Bind("title") %>' />
                    </td>
                </tr>
                <tr>
                    <td valign="top"></td>
                    <td>
    <asp:TextBox ID="txtContent" runat="server" Columns="35" Rows="8" TextMode="MultiLine" Text='<%# Bind("content") %>' />
                    </td>
                </tr>
                <tr>
                    <td valign="top">Ѽ</td>
                    <td>
                    <table border="0" cellpadding="0">
                        <tr style="color:Blue">
                            <td align="center"><b></b></td>
                            <td align="center"><b></b></td>
                        </tr>
                        <tr>
                            <td valign="top">
                        <asp:CheckBoxList ID="cblRoles" runat="server">
                        </asp:CheckBoxList>
                            </td>
                            <td valign="top">
                        <asp:CheckBoxList ID="cblUsers" runat="server">
                        </asp:CheckBoxList>
                            </td>
                        </tr>
                    </table>
                     </td>
                </tr>
                <tr>
                    <td></td>
                    <td>
    <asp:LinkButton ID="InsertButton" runat="server"    
        CommandName="Update" Text="Ȯ" />
    <asp:LinkButton ID="CancelButton" runat="server" 
        CommandName="Cancel" Text="" />
    <asp:HyperLink ID="hlToList" runat="server" Text="" />
                    </td>
                </tr>
            </table>
        </EditItemTemplate>
        <InsertItemTemplate>
            <table border="0" cellpadding="0" width="100%">
                <tr>
                    <td width="100"><b>̵</b></td>
                    <td>
    <asp:Label ID="lblUserName" runat="server" Text="<%# User.Identity.Name %>" />
                    </td>
                </tr>
                <tr>
                    <td><b></b></td>
                    <td>
    <asp:TextBox ID="txtTitle" runat="server" Text='<%# Bind("title") %>' />
                    </td>
                </tr>
                <tr>
                    <td valign="top"><b></b></td>
                    <td>
    <asp:TextBox ID="txtContent" runat="server" Columns="35" Rows="8" 
        TextMode="MultiLine" Text='<%# Bind("content") %>' />
                    </td>
                </tr>
                <tr>
                    <td valign="top"><b>Ѽ</b></td>
                    <td>
                    <table border="0" cellpadding="0">
                        <tr style="color:Blue">
                            <td align="center"></td>
                            <td align="center"></td>
                        </tr>
                        <tr>
                            <td valign="top">
            <asp:CheckBoxList ID="cblRoles" runat="server" />
                            </td>
                            <td valign="top">
            <asp:CheckBoxList ID="cblUsers" runat="server" />
                            </td>
                        </tr>
                    </table>
                    </td>
                </tr>
                <tr>
                    <td></td>
                    <td>
    <asp:LinkButton ID="InsertButton" runat="server" 
        CommandName="Insert" Text="߰" />
    <asp:HyperLink ID="hlToList" runat="server" Text="" />
                    </td>
                </tr>
            </table>
        </InsertItemTemplate>
    </asp:FormView>
    <asp:ObjectDataSource ID="ObjectDataSource1" 
        runat="server" TypeName="BoardCompont" 
        SelectMethod="GetItem" InsertMethod="InsertItem" 
        DeleteMethod="DeleteItem" UpdateMethod="UpdateItem" 
        OnSelecting="ObjectDataSource1_Selecting" 
        OnDeleting="ObjectDataSource1_Deleting">
        <SelectParameters>
            <asp:Parameter Name="board" Type="Object" />
            <asp:QueryStringParameter DefaultValue="-1" Name="no" QueryStringField="no" Type="Int32" />
        </SelectParameters>
        <InsertParameters>
            <asp:Parameter Name="board" Type="Object" />
            <asp:Parameter Name="writerName" Type="String" />
            <asp:Parameter Name="title" Type="String" />
            <asp:Parameter Name="content" Type="String" />
            <asp:Parameter Name="allowRoles" Type="String" />
            <asp:Parameter Name="allowUsers" Type="String" />
        </InsertParameters>
        <DeleteParameters>
            <asp:Parameter Name="board" Type="Object" />
            <asp:QueryStringParameter Name="no" QueryStringField="no" Type="Int32" />
        </DeleteParameters>
        <UpdateParameters>
            <asp:Parameter Name="board" Type="Object" />
            <asp:QueryStringParameter Name="no" QueryStringField="no" Type="Int32" />
            <asp:Parameter Name="title" Type="String" />
            <asp:Parameter Name="content" Type="String" />
            <asp:Parameter Name="allowRoles" Type="String" />
            <asp:Parameter Name="allowUsers" Type="String" />
        </UpdateParameters>
    </asp:ObjectDataSource>
</asp:Content>
