<%@ Control Language="C#" ClassName="RecentBoardList" %>
<%@ Implements Interface="System.Web.UI.WebControls.WebParts.IWebPart" %>
<%@ Import Namespace="System.Web.UI.WebControls.WebParts" %>
<script runat="server">
    int _topCount = 3;
    int _boardNo = -1;
    BoardClass _board = null;

    private BoardClass Board {
        get {
            if (_board == null && _boardNo != -1) {
                string connStr = ConfigurationManager.ConnectionStrings["MySqlConnection"].ConnectionString;
                _board = new BoardClass(_boardNo, connStr);
            }
            return _board;
        }
    }
    
    [Personalizable]
    public int TopCount {
        get { return _topCount; }
        set { _topCount = value; }
    }
    
    [Personalizable]
    public int BoardNo {
        get { return _boardNo; }
        set { _boardNo = value; }
    }

    private String _catalogImageUrl = string.Empty;
    private String _description = string.Empty;

    public String CatalogIconImageUrl
    {
        get { return _catalogImageUrl; }
        set { _catalogImageUrl = value; }
    }
    
    public String Description
    {
        get { return _description; }
        set { _description = value; }
    }
    
    public String Subtitle
    {
        get { return string.Empty; }
        set { ; }
    }
    
    public String Title
    {
        get {
            if (Board != null)
                return Board.Subject;
            else
                return "";
        }
        set { ; }
    }
    
    public String TitleIconImageUrl
    {
        get { return string.Empty; }
        set { ; }
    }
    
    public String TitleUrl
    {
        get { return string.Empty; }
        set { ; }
    }
    
    protected void odsBoard_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        if (_boardNo == -1) {
            e.Cancel = true;
            return;
        }

        if (!Board.IsAuthenticatedUser) {
            e.Cancel = true;
            lblAccessDenide.Visible = true;
            return;
        }
        e.InputParameters["board"] = Board;
        e.InputParameters["topCount"] = _topCount;
    }

    protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow) {
            ItemClass item = (ItemClass)e.Row.DataItem;
            if (!item.IsAuthenticatedUser)
                e.Row.Cells[2].Enabled = false;
        }
    }
</script>
<asp:Label ID="lblAccessDenide" runat="server" Visible="False" ForeColor="Red" Text="ٱ ϴ" />
<asp:GridView ID="GridView1" runat="server" 
    AutoGenerateColumns="False" DataSourceID="odsBoard" 
    OnRowDataBound="GridView1_RowDataBound" 
    CellPadding="4" ForeColor="#333333" GridLines="None">
    <Columns>
        <asp:BoundField DataField="No" HeaderText="No" SortExpression="No"/>
        <asp:BoundField DataField="WriterName" HeaderText="ۼ" 
            SortExpression="WriterName" />
        <asp:HyperLinkField DataNavigateUrlFields="BoardNo,No" 
            DataNavigateUrlFormatString="~/Board/Content.aspx?board={0}&no={1}"
            DataTextField="Title" HeaderText="" 
            SortExpression="Title">
            <ControlStyle Width="100px" />
        </asp:HyperLinkField>
        <asp:BoundField DataField="ReadCount" HeaderText="ȸ" 
            SortExpression="ReadCount" />
        <asp:BoundField DataField="RegDate" HeaderText="¥" 
            SortExpression="RegDate" DataFormatString="{0:yyyy-MM-dd}" />
        <asp:BoundField DataField="AllowRoles" HeaderText="AllowRoles" 
            SortExpression="AllowRoles" />
        <asp:BoundField DataField="AllowUsers" HeaderText="AllowUsers" 
            SortExpression="AllowUsers" />
    </Columns>
    <RowStyle BackColor="#EFF3FB" />
    <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
    <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
    <AlternatingRowStyle BackColor="White" />
</asp:GridView>
<asp:ObjectDataSource ID="odsBoard" runat="server" 
    TypeName="BoardCompont" SelectMethod="GetRecentItems" 
    OnSelecting="odsBoard_Selecting">
    <SelectParameters>
        <asp:Parameter Name="board" Type="Object" />
        <asp:Parameter Name="topCount" Type="Int32" />
    </SelectParameters>
</asp:ObjectDataSource>