using System;
using System.Configuration;
using System.ComponentModel;

namespace SimpleLog
{
    class SimpleLogConfigurationHandler : ConfigurationSection {
        [ConfigurationProperty("providers")]
        public ProviderSettingsCollection Providers {
            get {
                return ((ProviderSettingsCollection)base["providers"]);
            }
        }

        [TypeConverter(((Type)typeof(WhiteSpaceTrimStringConverter)))]
        [ConfigurationProperty("defaultProvider")]
        public string DefaultProvider {
            get {
                return ((String)base["defaultProvider"]);
            }
            set {
                base["defaultProvider"] = value;
            }
        }
        /*
        private static readonly ConfigurationProperty _propDefaultProvider;
        private static readonly ConfigurationProperty _propProviders;
        private static ConfigurationPropertyCollection _properties;

        protected override ConfigurationPropertyCollection Properties {
            get {
                return _properties;
            }
        }

        static SimpleLogConfigurationHandler() { 
            _propDefaultProvider =
                new ConfigurationProperty(
                    "defaultProvider", typeof(String), null,
                    ConfigurationPropertyOptions.None);
            _propProviders =
                new ConfigurationProperty(
                    "providers", typeof(ProviderSettingsCollection), null,
                    ConfigurationPropertyOptions.None);

            _properties = new ConfigurationPropertyCollection();
            _properties.Add(_propDefaultProvider);
            _properties.Add(_propProviders);
        }
         * */
    }
}
