using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections;
using System.Collections.Specialized;

using SimpleLogB;

namespace SqlSimpleLogProvider
{
    class SqlSimpleLogProvider : SimpleLogProvider
    {
        private string _connectionString;
        public SqlSimpleLogProvider(string name, NameValueCollection configValues)
        {
            _connectionString = ConfigurationManager.ConnectionStrings[configValues["connectionString"]].ConnectionString;

            // ޼ҵ ȣ this.Name ȴ.
            this.Initialize(name, configValues);
        }

        public override ICollection GetLogList()
        {
            string query = "SELECT * FROM SimpleLog";
            IDbConnection dbConnection = new SqlConnection(_connectionString);
            IDbCommand dbCommand = new SqlCommand();

            dbCommand.CommandText = query;
            dbCommand.Connection = dbConnection;

            IDbDataAdapter dataAdapter = new SqlDataAdapter();

            dataAdapter.SelectCommand = dbCommand;

            DataSet ds = new DataSet();

            dataAdapter.Fill(ds);

            return ds.Tables[0].DefaultView;
        }

        public override void WriteLog(string pageName, string userHostAddress)
        {
            string query = "INSERT INTO SimpleLog(PageName, UserIP, Time) VALUES (@pageName, @userIP, @time)";
            IDbConnection dbConnection = new SqlConnection(_connectionString);
            IDbCommand dbCommand = new SqlCommand();

            dbCommand.CommandText = query;
            dbCommand.Connection = dbConnection;

            IDataParameter dbParam;

            dbParam = new SqlParameter("@pageName", SqlDbType.VarChar, 100);
            dbParam.Value = pageName;
            dbCommand.Parameters.Add(dbParam);

            dbParam = new SqlParameter("@userIP", SqlDbType.VarChar, 20);
            dbParam.Value = userHostAddress;
            dbCommand.Parameters.Add(dbParam);

            dbParam = new SqlParameter("@time", SqlDbType.DateTime);
            dbParam.Value = DateTime.Now;
            dbCommand.Parameters.Add(dbParam);

            dbConnection.Open();
            try
            {
                dbCommand.ExecuteNonQuery();
            }
            finally
            {
                dbConnection.Close();
            }

        }
    }
}
