using System;
using System.IO;
using System.Collections;
using System.Collections.Specialized;
using System.Xml;
using System.Data;
using System.Web;

using SimpleLogB;

namespace XmlSimpleLogProvider
{
    class XmlSimpleLogProvider : SimpleLogProvider
    {
        private string _logFile;
        public XmlSimpleLogProvider(string name, NameValueCollection configValues)
        {
            _logFile = HttpContext.Current.Server.MapPath(configValues["connectionString"]);

            // ޼ҵ ȣ this.Name ȴ.
            this.Initialize(name, configValues);
        }

        public override ICollection GetLogList()
        {
            string xmlStr;

            using (StreamReader sr = new StreamReader(_logFile))
            {
                xmlStr = sr.ReadToEnd();
            }

            DataTable dt = new DataTable();
            DataColumn dc;

            dc = new DataColumn("PageName", typeof(string));
            dt.Columns.Add(dc);
            dc = new DataColumn("UserIP", typeof(string));
            dt.Columns.Add(dc);
            dc = new DataColumn("Time", typeof(DateTime));
            dt.Columns.Add(dc);

            XmlDocument doc = new XmlDocument();
            doc.LoadXml("<SimpleLog>" +
                         xmlStr +
                        "</SimpleLog>");

            XmlNode log = doc.FirstChild.FirstChild;
            DataRow dr;
            while ((log = log.NextSibling) != null) {
                dr = dt.NewRow();

                dr["PageName"] = log.Attributes["PageName"].Value;
                dr["UserIP"] = log.Attributes["UserIP"].Value;
                dr["Time"] = DateTime.Parse(log.Attributes["Time"].Value);
                dt.Rows.Add(dr);
            }

            return dt.DefaultView;
        }

        public override void WriteLog(string pageName, string userHostAddress)
        {
            using (FileStream fs = new FileStream(_logFile, FileMode.Append))
            {
                StreamWriter sw = new StreamWriter(fs);
                sw.WriteLine();

                XmlTextWriter writer = new XmlTextWriter(sw);

                writer.WriteStartElement("log");
                writer.WriteAttributeString("PageName", pageName);
                writer.WriteAttributeString("UserIP", userHostAddress);
                writer.WriteAttributeString("Time", DateTime.Now.ToString());
                writer.WriteEndElement();

                writer.Flush();
            }
        }
    }
}
